var _options = 'option1'
$(function () {
  $('.multipage-all p i').html(parent.signName)
  //骑缝章，只能连续签章
  if (parent.sealType === 3) {
    $('.assign').hide()
  }
  /**
   * @description: 选择形式切换
   * @return {*} void
   */
  $('input[type=radio][name=optionsRadios]').change(function () {
    _options = $(this).val()
    if (_options === 'option1') {
      $('.multipage-all').show()
      $('.multipage-assign').hide()
    } else {
      $('.multipage-assign').show()
      $('.multipage-all').hide()
    }
  })

  /**
   * @description: 连续页面问号移入显示tips
   * @return {*} void
   */
  $('.continuous')
    .children('.tips')
    .mouseenter(function () {
      $('.tips-continuous').toggle()
    })

  /**
   * @description: 连续页面问号移出隐藏tips
   * @return {*} void
   */
  $('.continuous')
    .children('.tips')
    .mouseleave(function () {
      $('.tips-continuous').toggle()
    })

  /**
   * @description: 指定页面问号移入显示tips
   * @return {*} void
   */
  $('.assign')
    .children('.tips')
    .mouseenter(function () {
      $('.tips-assign').toggle()
    })

  /**
   * @description: 指定页面问号移出隐藏tips
   * @return {*} void
   */
  $('.assign')
    .children('.tips')
    .mouseleave(function () {
      $('.tips-assign').toggle()
    })

  /**
   * @description:关闭layer
   * @return {*} void
   */
  $('.multipage-handle-cancel').click(function () {
    let closeIndex = parent.layer.getFrameIndex(window.name)
    parent.result = 'close'
    parent.layer.close(closeIndex)
  })
  /**
   * @description: 印章签章
   * @return {*} void
   */
  $('.multipage-handle-confirm').click(function () {
    var closeIndex = parent.layer.getFrameIndex(window.name)
    var startPage = parseInt($('#startPage').val())
    var endPage = parseInt($('#endPage').val())
    if (_options === 'option1') {
      //全部页面
      parent.startPage = 1
      parent.endPage = parent.totalPages
      if (parent.sealType === 2) {
        // 多页签章
        formValid()
      } else {
        // 骑缝章
        parent.result = 'success'
        parent.layer.close(closeIndex)
      }
    } else {
      //指定页面
      parent.startPage =  startPage || parent.startPage
      parent.endPage =  endPage || parent.endPage
      if (parent.sealType === 2) {
        // 多页签章
        formValid()
      } else {
        // 骑缝章
        if (
          isNaN(startPage) ||
          isNaN(endPage) ||
          endPage < startPage ||
          startPage < 1
        ) {
          mAlert('请输入正确的页码')
          return
        }
        if (endPage == startPage && parent.sealType === 3) {
          mAlert('不支持对单页签骑缝章')
          return
        }
        if (endPage > parent.totalPages) {
          mAlert('您输入的页码超过了总页数')
          return
        }
        parent.result = 'success'
        parent.layer.close(closeIndex)
      }
    }
  })
})

/**
 * @description: 多页签章验证
 * @return {*} void
 */
function formValid() {
  var closeIndex = parent.layer.getFrameIndex(window.name)
  var totalPages = parent.totalPages
  var startPage = parent.startPage || ''
  var endPage = parent.endPage || ''
  var specifyPage = $('#specifyPage').val()
  var array = new Array()
  if ((startPage != '' || endPage != '') && specifyPage != '') {
    mAlert('请不要同时设置连续多页和指定页码')
    return
  }
  if (specifyPage != '') {
    //特定页码
    array = specifyPage.split(',')
    for (var i = 0; i < array.length; i++) {
      if (isNaN(array[i]) || array[i] < 1 || array[i] > totalPages) {
        mAlert('请输入正确的页码')
        return
      }
    }
    parent.multiPageType = '2'
    parent.endPage = array[array.length]
  } else {
    //连续页码
    startPage = parseInt(startPage)
    endPage = parseInt(endPage)
    if (
      isNaN(startPage) ||
      isNaN(endPage) ||
      endPage < startPage ||
      startPage < 1
    ) {
      console.log(endPage, startPage)
      mAlert('请输入正确的页码')
      return
    }
    if (endPage > totalPages) {
      mAlert('您输入的页码超过了总页数')
      return
    }
    for (var i = startPage; i <= endPage; i++) {
      array.push(i)
    }
    parent.multiPageType = '1'
    parent.endPage = endPage
  }
  parent.pageArray = array
  parent.result = 'success'
  parent.layer.close(closeIndex)
}

/**
 * @description: 公用弹出组件
 * @param {*} msg 消息
 * @param {*} func 回调
 * @return {*}
 */
function mAlert(msg, func) {
  parent.layer.alert(
    msg,
    {
      icon: typeof func === 'number' ? func : 0,
      title: '提示',
    },
    function (index) {
      if (func && typeof func == 'function') {
        func()
      }
      parent.layer.close(index)
    }
  )
}
