var uuid = "";
var timer = null;
var timeout = 0;
var count = 0;
$(function () {
  // $('.success-tips').hide()
  if (parent.qrCodetype === 1) {
    getQrCode();
  } else {
    getQrCodeSign();
  }
  // 读取UKEY
  $(".readSign").click(function () {
    //清除样章
    var closeIndex = parent.layer.getFrameIndex(window.name);
    if (parent.urlParams("certtype") != 1) {
      parent.certType = 1;
      return replaceParamVal("certtype", 1);
    } else {
      parent.clearSign();
      parent.certType = 1;
      parent.setCertType();
    }
    parent.layer.close(closeIndex);
  });
  /**
   * @description: 点击刷新二维码
   * @return {*} void
   */
  $(".qrcode-reset-btn").click(function () {
    if (parent.qrCodetype === 1) {
      getQrCode();
    } else {
      getQrCodeSign();
    }
  });
});
/**
 * @description: 修改url参数
 * @param {*} paramName 参数名
 * @param {*} replaceWith 参数值
 * @return {*} void
 */
function replaceParamVal(paramName, replaceWith) {
  var oUrl = parent.location.href.toString();
  var re = eval("/(" + paramName + "=)([^&]*)/gi");
  var nUrl = oUrl.replace(re, paramName + "=" + replaceWith);
  parent.location = nUrl;
  parent.location.href = nUrl;
}
/**
 * @description: 创建登陆二维码
 * @return {*} void
 */
function getQrCode() {
  var params = {
    funcName: "CreateQr", //createqrcodeV3
    param: {
      type: "login",
      certSn: "",
      reqData: {
        hashData: "",
        toBeSign: "",
      },
    },
  };
  $.ajax({
    type: "post",
    url: "https://localhost:9819/HxApi",
    data: JSON.stringify(params),
    timeout: 10000,
    dataType: "json",
    success: function (data) {
      if (data.retcode != 0) {
        mAlert(
          data.retvalue.errorMsg || "二维码创建失败，请检测网络连接再重试。"
        );
        return;
      }
      if (data.retcode === 0) {
        if (data.retvalue.ErrCode == -1) {
          return mAlert(data.retvalue.ErrValue || "调用控件异常");
        }
        $('.qrcode-reset').hide()
        timeout = Number(data.retvalue.timeout);
        $(".qrcode-img").attr(
          "src",
          "data:image/png;base64," + data.retvalue.picdata
        );
        uuid = data.retvalue.uuid;
        timer = window.setTimeout(function () {
          timerGetQrcode();
        }, 2000);
      }
    },
    error: function (err) {
      return mAlert("调用控件异常");
    },
  });
}

/**
 * @description: 轮询登陆状态
 * @return {*} void
 */
function timerGetQrcode() {
  let params = {
    funcName: "GetQrRequestbyuuid",
    param: {
      uuid: uuid,
    },
  };
  $.ajax({
    type: "post",
    url: "https://localhost:9819/HxApi",
    data: JSON.stringify(params),
    dataType: "json",
    timeout: 30000,
    success: function (data) {
      if (data.retcode != 0) {
        mAlert(
          data.retvalue.errorMsg ||
            "链接超时请检查电脑的网络设置，确认网络通畅后再次操作。"
        );
        count = 0;
        window.clearTimeout(timer);
        if (parent.qrCodetype === 1) {
          getQrCode();
        } else {
          getQrCodeSign();
        }
        return;
      }
      if (data.retvalue.rslt !== "fail") {
        count = 0;
        window.clearTimeout(timer);
        var sizeTime = null;
        var sizeTimeNum = 3;
        //登陆二维码
        if (parent.qrCodetype === 1) {
          $(".success-tips").show();
          //公司名称
          window.localStorage.removeItem("givenName");
          parent.userInfoParams = data.retvalue.data;
          window.localStorage.setItem(
            "givenName",
            data.retvalue.data.certdata.givenName
          );
          //数字证书
          window.localStorage.removeItem("serialNumber");
          window.localStorage.setItem(
            "serialNumber",
            data.retvalue.data.certdata.serialNumber
          );
          parent.certSn = data.retvalue.data.certdata.serialNumber;
          parent.settingComName(data.retvalue.data.certdata.givenName); //设置公司名字
        } else {
          setSignDataToPdf(data.retvalue.data.signdata); //设置签名
        }
        sizeTime = window.setInterval(function () {
          sizeTimeNum--;
          $(".countTime").html(sizeTimeNum);
          if (sizeTimeNum === 0) {
            window.clearInterval(sizeTime);
            parent.result = "success";
            $(".success-tips").hide();
            if (parent.urlParams("certtype") != 2) {
              //url参数不是2 需要修改成2后刷新
              parent.certType = 2;
              //刷新前要重新请求SetCertType、SetUserInfo两个接口，两个接口重新写了个方法。
              return signMobile();
            } else {
              // url是2不需要刷新，要处理页面。
              parent.clearSign();
              parent.certType = 2;
              parent.setUserInfo(); //设置用户信息
              var closeIndex = parent.layer.getFrameIndex(window.name);
              parent.layer.close(closeIndex);
            }
          }
        }, 1000);
      } else {
        if (data.retvalue.errorCode === "ERROR_009") {
          count = 0;
          window.clearTimeout(timer);
          //二维码失效
          mAlert(data.retvalue.errorMsg || "调用控件异常");
          $(".qrcode-reset").show();
        } else if (data.retvalue.errorCode === "ERROR_014") {
          //未上传结果
          timer = window.setTimeout(function () {
            timerGetQrcode();
          }, 2000);
        }
      }
    },
    error: function (err) {
      mAlert("调用控件异常");
      $(".qrcode-reset-btn").show();
      window.clearTimeout(timer);
    },
  });
}

/**
 * @description: 创建签名二维码
 * @return {*} void
 */
function getQrCodeSign() {
  var params = {
    funcName: "CreateQr",
    param: {
      type: "sign",
      certSn:
        parent.certSn || window.localStorage.getItem("serialNumber") || "",
      reqData: {
        hashData: parent.hashData || "",
        toBeSign: "",
      },
    },
  };
  $.ajax({
    type: "post",
    url: "https://localhost:9819/HxApi",
    data: JSON.stringify(params),
    timeout: 10000,
    dataType: "json",
    success: function (data) {
      if (data.retcode != 0) {
        mAlert(
          data.retvalue.errorMsg || "二维码创建失败，请检测网络连接再重试。"
        );
        return;
      } else {
        if (data.retvalue.ErrCode == -1) {
          return mAlert(data.retvalue.ErrValue || "调用控件异常");
        }
      }
      if (data.retvalue.rslt !== "fail") {
        $('.qrcode-reset').hide()
        timeout = Number(data.retvalue.timeout);
        $(".qrcode-img").attr(
          "src",
          "data:image/png;base64," + data.retvalue.picdata
        );
        uuid = data.retvalue.uuid;
        timer = window.setTimeout(function () {
          // getQrCode()
          timerGetQrcode();
        }, 2000);
      } else {
        mAlert(data.retvalue.errorMsg);
      }
    },
    error: function (err) {
      return mAlert("调用控件异常");
    },
  });
}

/**
 * @description: 设置签名结果
 * @return {*} void
 */
function setSignDataToPdf(signData) {
  let closeIndex = parent.layer.getFrameIndex(window.name);
  var params = {
    funcName: "SetSignDataToPdf",
    param: {
      signedData: signData,
      SigncertSn:
        parent.certSn || window.localStorage.getItem("serialNumber") || "",
    },
  };
  $.ajax({
    type: "post",
    url: "https://localhost:9819/HxApi",
    data: JSON.stringify(params),
    dataType: "json",
      success: function (data) {
          console.log(data)
      if (data.retcode != 0) {
        mAlert(
            data.errinfo || "设置签名结果失败，请检测网络连接再重试。"
        );
        parent.layer.close(closeIndex);
        return;
      }
      if (data.retcode === 0) {
        if (data.retvalue.ErrCode == -1) {
          return mAlert(data.retvalue.ErrValue || "调用控件异常");
        }
        parent.result = "qrcodeOK";
        parent.layer.close(closeIndex);
      }
    },
    error: function (err) {
      return mAlert("调用控件异常");
    },
  });
}
/**
 * @description: 公用弹出组件
 * @param {*} msg 消息
 * @param {*} func 回调
 * @return {*} void
 */
function mAlert(msg, func) {
    var locaParent = parent;
  parent.layer.alert(
    msg,
    {
      icon: typeof func === "number" ? func : 0,
      title: "提示",
    },
      function (index) {
      if (func && typeof func == "function") {
        func();
      }
      locaParent.layer.close(index);
    }
  );
}

/**
 * @description: 移动证书重新刷新前要调用setuserinfo
 * @return {*} void
 */
function signMobile() {
  var paramsInfo = {
    funcName: "SetUserInfo",
    param: {
      SignCert: parent.userInfoParams.cert,
      EncCert: parent.userInfoParams.encCert,
      certdata: {
        givenName: parent.userInfoParams.certdata.givenName,
        commonName: parent.userInfoParams.certdata.commonName,
        serialNumber: parent.userInfoParams.certdata.serialNumber,
        issuerCn: parent.userInfoParams.certdata.issuerCn,
        startDate: parent.userInfoParams.certdata.startDate,
        finalDate: parent.userInfoParams.certdata.finalDate,
        uniscid: parent.userInfoParams.certdata.uniscid,
        zch: parent.userInfoParams.certdata.zch,
        corpid: "内部序号",
        ou: "ou",
      },
      proxName: parent.userInfoParams.proxName || "",
      proxCardNumber: parent.userInfoParams.proxCardNumber || "",
      proxPhone: parent.userInfoParams.proxPhone || "",
      qrCodeType: parent.userInfoParams.qrCodeType || "",
    },
  };
  $.ajax({
    type: "post",
    url: "https://localhost:9819/HxApi",
    data: JSON.stringify(paramsInfo),
    dataType: "json",
    timeout: 10000,
    success: function (data) {
      if (data.retcode != 0) {
        mAlert(data.errinfo || "设置用户信息失败，请检测网络连接再重试。");
        return;
      }
      if (data.retcode === 0) {
        if (data.retvalue.ErrCode == -1) {
          return mAlert(data.retvalue.ErrValue || "调用控件异常");
        }
        return replaceParamVal("certtype", 2);
      }
    },
    error: function () {
      return mAlert("调用控件异常");
    },
  });
}
