$(function () {
    init();
})

/**
 * 初始化函数集合
 */
function init() {
    formValid();
    bindEvent();
}

/**
 * 表单验证
 */
function formValid() {
    $('#setPageNumForm').validate({
        rules: {
            keyWord: {
                required: true
            }
        },
        messages: {
            keyWord: {
                required: '请输入关键字'
            }
        },
        showErrors: function (errorMap, errorList) {
            for (var i in errorMap) {
                layer.tips(errorMap[i], $('#setPageNumForm input[name=' + i + ']'), {
                    tips: 3,
                    tipsMore: true,
                    ltype: 0
                });
            }
        },
        submitHandler: function () {
            var keyWord = $("#keyWord").val();

            $.ajax({
                type: "get",
                async: false,
                url: "https://localhost:9819/?method=65",
                data: {
                    "keyword": keyWord
                },
                dataType: "jsonp",
                jsonp: "callback",//传递给请求处理程序或页面的，用以获得jsonp回调函数名的参数名(一般默认为:callback)
                jsonpCallback: "myjsonpcall",//自定义的jsonp回调函数名称，默认为jQuery自动生成的随机函数名，也可以写"?"，jQuery会自动为你处理数据
                success: function (data) {
                    if (data.retcode != 0) {
                        mAlert("关键字查询失败");
                        return;
                    } else {
                        parent.result = "success";
                        parent.keyWordPosition = data.retvalue.position;
                        parent.layer.close(parent.index);
                    }
                }
            });
        }
    })
}

function mAlert(msg, func) {
    layer.alert(msg, {
        icon: typeof (func) === 'number' ? func : 0,
        title: '提示'
    }, function (index) {
        if (func && typeof(func) == "function") {
            (func)();
        }
        layer.close(index);
    });
}

function bindEvent() {
    $('#cancel_btn').bind("click", function () {
        parent.result = "close";
        parent.layer.close(parent.index);
    });
}
