$(function () {
    init();
})

/**
 * 初始化函数集合
 */
function init() {
    formValid();
    bindEvent();
}

/**
 * 表单验证
 */
function formValid() {
    $('#setPageNumForm').validate({
        submitHandler: function () {
            var totalPages = parent.totalPages;
            var startPage = parseInt($("#startPage").val());
            var endPage = parseInt($("#endPage").val());
            if (isNaN(startPage) || isNaN(endPage) || endPage < startPage || startPage < 1) {
                mAlert("请输入正确的页码");
                return;
            }
            if (endPage == startPage) {
                mAlert("不支持对单页签骑缝章");
                return ;
            }
            if (endPage > totalPages) {
                mAlert("您输入的页码超过了总页数");
                return;
            }
            parent.startPage = startPage;
            parent.endPage = endPage;
            parent.result = 'success';
            parent.layer.close(parent.index);
        }
    })
}

function bindEvent() {
    $('#cancel_btn').bind("click", function () {
        parent.result = "close";
        parent.layer.close(parent.index);
    });

    $("#allPage").bind("click", function () {
        var totalPages = parent.totalPages;
        var isChecked = $(this).prop("checked");
        if (isChecked) {
            $("#startPage").val(1);
            $("#endPage").val(totalPages);
            $("#startPage").attr("disabled", true);
            $("#endPage").attr("disabled", true);
        } else {
            $("#startPage").val("");
            $("#endPage").val("");
            $("#startPage").attr("disabled", false);
            $("#endPage").attr("disabled", false);
        }
    })
}

function mAlert(msg, func) {
    layer.alert(msg, {
        icon: typeof (func) === 'number' ? func : 0,
        title: '提示'
    }, function (index) {
        if (func && typeof(func) == "function") {
            (func)();
        }
        layer.close(index);
    });
}
