/*
 * @Author: your name
 * @Date: 2020-12-21 10:47:58
 * @LastEditTime: 2020-12-29 15:45:49
 * @LastEditors: your name
 * @Description: In User Settings Edit
 * @FilePath: \Web\web\js\setPageNum_main2.js
 */
$(function () {
    init();
})

/**
 * 初始化函数集合
 */
function init() {
    formValid();
    bindEvent();
}

/**
 * 表单验证
 */
function formValid() {
    $('#setPageNumForm').validate({
        submitHandler: function () {
            var totalPages = parent.totalPages;
            var startPage = $("#startPage").val();
            var endPage = $("#endPage").val();
            var specifyPage = $("#specifyPage").val();
            var array = new Array();
            if ((startPage != "" || endPage != "") && specifyPage != "") {
                mAlert("请不要同时设置连续多页和指定页码");
                return ;
            }
            if (specifyPage != "") {//特定页码
                array = specifyPage.split(",");
                for (var i = 0; i < array.length; i++) {
                    if (isNaN(array[i]) || array[i] <1 || array[i] > totalPages) {
                        mAlert("请输入正确的页码");
                        return ;
                    }
                }
                parent.multiPageType = '2';
                parent.endPage = array[array.length];
            } else {//连续页码
                startPage = parseInt(startPage);
                endPage = parseInt(endPage);
                if (isNaN(startPage) || isNaN(endPage) || endPage < startPage || startPage < 1) {
                    mAlert("请输入正确的页码");
                    return;
                }
                if (endPage > totalPages) {
                    mAlert("您输入的页码超过了总页数");
                    return;
                }
                for (var i = startPage; i <= endPage; i++) {
                    array.push(i);
                }
                parent.multiPageType = '1';
                parent.endPage = endPage;
            }
            parent.pageArray = array;
            parent.result = 'success';
            parent.layer.close(parent.index);
        }
    })
}

function bindEvent() {
    $('#cancel_btn').bind("click", function () {
        parent.result = "close";
        parent.layer.close(parent.index);
    });

    $("#allPage").bind("click", function () {
        var totalPages = parent.totalPages;
        var isChecked = $(this).prop("checked");
        if (isChecked) {
            $("#startPage").val(1);
            $("#endPage").val(totalPages);
            $("#specifyPage").val("");
            $("#startPage").attr("disabled", true);
            $("#endPage").attr("disabled", true);
            $("#specifyPage").attr("disabled", true);
        } else {
            $("#startPage").val("");
            $("#endPage").val("");
            $("#specifyPage").val("");
            $("#startPage").attr("disabled", false);
            $("#endPage").attr("disabled", false);
            $("#specifyPage").attr("disabled", false);
        }
    })
}

function mAlert(msg, func) {
    layer.alert(msg, {
        icon: typeof (func) === 'number' ? func : 0,
        title: '提示'
    }, function (index) {
        if (func && typeof(func) == "function") {
            (func)();
        }
        layer.close(index);
    });
}
