;(function ($) {
    $.fn.createSign = function (options, callback) {
      var defaults = {
        width: '119.5',
        height: '119.5',
        top: '0',
        left: '0',
        cssClass: 'sealClass',
        page: '1',
      }
      var opts = $.extend(defaults, options)
      if (!opts['sealImgBase64']) {
        throw new Error('必须设置签章图片。')
        return
      }
      // 骑缝章时,跳过边界处理
      // 传入的left按真实宽高处理过了,如果处理,未渲染页面通过下面的 this.width() 拿到的页面的宽度是默认宽度，非页面实际宽度，会导致处理的数据不正确
      // if(opts.type != 'QF') {
      //   //防止印章越过界
      //   if (opts.left < 0) {
      //     opts.left = 0
      //   } else if (opts.left >= this.width() - opts.width) {
      //     opts.left = this.width() - opts.width
      //   }
      //   if (opts.top < 0) {
      //     opts.top = 0
      //   } else if (opts.top >= this.height() - opts.height) {
      //     opts.top = this.height() - opts.height
      //   }
      // }
      //生成一个div
      var signObj = $('<div/>').css({
        width: opts.width,
        height: opts.height,
        top: opts.top,
        left: opts.left,
        'background-image':
          "url('data:image/png;base64," + opts.sealImgBase64 + "')",
        'background-repeat': 'no-repeat',
        'background-size': 'contain',
        'background-position': 'center center',
        position: 'absolute',
        'z-index': '1',
        opacity: '0.8',
      })
      if (opts.type == 'multiPage') {
        //多页
        var delButton =
          "<button name='delButton' class='btn' style='position: absolute;margin-top: 0px;right: 0px;background: black;opacity: 0.5;'>X</button>"
        signObj.html(delButton)
        //绑定点击删除事件
        signObj.children("[name='delButton']").click(function (e) {
          var row = $(e.target).parent().data('position')
          mConfirm('确认要删除当前签章位置吗？', function () {
            signObj.remove()
            window.deleteSign(row)
          })
        })
        signObj.attr('name', 'freeSignSeal')
        //如果是多页签章，则给signObj加上标识
        signObj.attr('data-type', 'multiPage')
        //记录要加印章的页数，图片base64以及图片id
        signObj.data('multiPageInfo', {
          pageArray: opts.pageArray,
          sealImgBase64: opts.sealImgBase64,
          sealId: opts.sealId,
        })
      } else if (opts.type == 'QF') {
        //骑缝
        signObj.attr('name', 'QFSeal')
      } else {
        //单页和关键字
        var delButton =
          "<button name='delButton' class='btn' style='position: absolute;margin-top: 0px;top:0px;right: 0px;background: black;opacity: 0.5;'>X</button>"
        signObj.append(delButton)
        //绑定点击删除事件
        signObj.children("[name='delButton']").click(function (e) {
          var row = $(e.target).parent().data('position')
          mConfirm('确认要删除当前签章位置吗？', function () {
            signObj.remove()
            window.deleteSign(row)
          })
        })
        signObj.attr('name', 'freeSignSeal')
      }
      signObj.addClass('seal')
      if (opts.cssClass) {
        signObj.addClass(opts.cssClass)
      }
      this.append(signObj)
      // var _default_lly = this.height() - opts.top - signObj.height();
      var realSealLeft = opts.left / window.preScale /  window.pageScale
      var realSealTop = opts.top / window.preScale /  window.pageScale
      //默认位置
      signObj.data('position', {
        llx: opts.left,
        lly: opts.top,
        page: opts.page,
        sealId: opts.sealId,
        pageWidth: this.width(),
        type: opts.type,
        sealType: opts.sealType,
        signSelfType: opts.signSelfType,
        timeStamp: opts.timeStamp,
        realSealWidth: opts.realSealWidth,
        realSealHeight: opts.realSealHeight,
        realSealLeft: realSealLeft || opts.realSealLeft,
        realSealTop: realSealTop || opts.realSealTop,
        tipPages: opts.tipPages
      })
  
      var moveAreaObj = this
      var isDrag = false
      var startX, startY, startLeft, startTop
  
      if (opts.type != 'QF') {
        signObj[0].addEventListener('touchstart', function (e) {
          isDrag = true
          startX = e.touches[0].pageX
          startY = e.touches[0].pageY
          var offset = $(this).offset()
          startLeft = offset.left
          startTop = offset.top
          return false
        })
        signObj[0].addEventListener('touchmove', function (e) {
          e.preventDefault()
          if (isDrag) {
            var endLeft =
              startLeft + e.touches[0].pageX - startX - moveAreaObj.offset().left
            var endTop =
              startTop + e.touches[0].pageY - startY - moveAreaObj.offset().top
  
            setPosition({ left: endLeft, top: endTop })
          }
          return false
        })
  
        signObj[0].addEventListener('touchend', function () {
          isDrag = false
          if (opts['endMove'] && typeof opts['endMove'] == 'function') {
            opts['endMove'](signObj)
          }
        })
  
        signObj.mousedown(function (event) {
          $(this).css('cursor', 'move')
  
          var offset = $(this).offset()
          var x = event.pageX - offset.left
          var y = event.pageY - offset.top
  
          var signObj = $(this)
          var left = 0
          var top = 0
          $(document).bind('mousemove', function (event) {
            left = event.pageX - x - moveAreaObj.offset().left
            top = event.pageY - y - moveAreaObj.offset().top
            setPosition({ left: left, top: top })
          })
          $(document)
            .unbind('mouseup')
            .bind('mouseup', function () {
              signObj.css('cursor', 'default')
              if (opts['endMove'] && typeof opts['endMove'] == 'function') {
                opts['endMove']({ signObj: signObj, left: left, top: top })
              }
              $(this).unbind('mousemove mouseup')
            })
        })
      }
  
      function mConfirm(msg, success) {
        layer.confirm(msg, { icon: 3, title: '提示' }, function (index) {
          if (success && typeof success == 'function') {
            success()
          }
          layer.close(index)
        })
      }
  
      //设置印章位置
      function setPosition(offset) {
        var left = offset.left
        var top = offset.top
        if (left < 0) {
          left = 0
        } else if (left >= moveAreaObj.width() - signObj.width()) {
          left = moveAreaObj.width() - signObj.width()
        }
  
        if (top < 0) {
          top = 0
        } else if (top >= moveAreaObj.height() - signObj.height()) {
          top = moveAreaObj.height() - signObj.height()
        }
        signObj.css({ left: left + 'px', top: top + 'px' })
        // var lly = moveAreaObj.height() - top - signObj.height();
        //签章新位置
        var positionData = signObj.data('position')
        var realSealWidth = positionData.realSealWidth
        var realSealHeight = positionData.realSealHeight;
  
        // var realSealLeft = opts.left / window.preScale /  window.pageScale
        // var realSealTop = opts.top / window.preScale /  window.pageScale
        
        signObj.data('position', {
          llx: left,
          lly: top,
          page: opts.page,
          sealId: opts.sealId,
          pageWidth: moveAreaObj.width(),
          type: opts.type,
          sealType: opts.sealType,
          signSelfType: opts.signSelfType,
          timeStamp: opts.timeStamp,
          realSealWidth: realSealWidth || opts.realSealWidth,
          realSealHeight: realSealHeight || opts.realSealHeight,
          realSealLeft: opts.realSealLeft,
          realSealTop: opts.realSealTop,
          tipPages: opts.tipPages
        })
        if (callback) {
          callback(left, top)
        }
      }
      return signObj
    }
  })(jQuery)
  