var pageNum = 1,
    certSerialNum = null,
    //页面展示大小和pdf真实页面大小之比
    scale,
    //选中的印章图片base64
    selectedSealImgBase64 = null,
    //选中的印章图片id
    selectedSealId = null,
    //选中的印章图片id
    selectedSealType = null,
    //应用系统
    appid = "TP",
    //服务器地址
    serverurl = "http://ztbsign.icinfo.cn",
    //密钥
    secret = "633c0cb6f45b11e7971e00188b839ae8",
    //签名值
    signdata,
    //二维码base64
    picdata,
    //轮询时的uuid
    uuid,
    //二维码失效时间
    timeout,
    //layer序号
    index,
    //改变前scale
    preScale = 1,
    //改变后scale
    aftScale = 1,
    //签章类型
    signType,
    //二维码类型
    qrCodetype,
    //印章数组
    sealInfoArray,
    //弹出层返回结果
    result,
    startPage,
    endPage,
    pageArray,
    /** 页面是否正在缩放 */
    isZoom,
    /** 页面缩放时不画签章，但是把要画的页码放进数组中，缩放完成后立即画 */
    zoomPageArr = [],
    //文档总页数
    totalPages,
    //公章默认大小
    sealDefaultSize = 119,
    //法人章默认大小
    frzSealDefaultSize = 119,
    /** 合同章默认大小 */
    contractzSealDefaultSize = 119,
    //手写签名默认大小
    sxqmSealDefaultSize = 119,
    //经办人章默认大小
    agentSealDefaultSize = 119,
    //关键字坐标数组
    keyWordPosition,
    //骑缝章的位置信息
    QFDataList = new Array(),
    /**
     * @typedef RealPDF 后端传入的pdf真实数据详情
     * @property {number} iPageNo 页码
     * @property {number} iPageSize 页码真实宽度
     * @property {number} iPageHeight 页码真实高度
     */
    /** @type {RealPDF[]} pdf真实页面宽度数组 */
    realWidthArray,
    /**
     * @typedef RealPageInfo pdf 真实页面宽高对象
     * @property {RealPDF['iPageSize']} pageWidth 页码真实宽度
     * @property {RealPDF['iPageHeight']} pageHeight 页码真实高度
     */
    /**
     * @type {{[key:number]:RealPageInfo}} pdf 真实页面宽高对象
     */
    realPageInfo = {},
    //多页签类型 1连续；2指定
    multiPageType,
    sealSignEnd,
    frSignEnd,
    agentSignEnd,
    sxqmSignEnd,
    /** @type {number} 真正使用的签章宽度 */
    signWidth, // 印章宽度
    signHeight, // 印章高度
    fullSize, // 印章实际大小
    userInfoParams = null, //SetUserInfo 扫描二维码后所获得的参数
    certSn,
    hashData,
    toBeSign,
    moveSign,
    /**
     *  页面dom宽度相对于后端返回的真实宽度的比值
     */
    pageScale,
    tipsMessag, //公共组件信息
    tipsType, //公共组件状态
    minWidth = 119, //最小宽度
    closeQrType = 1, // login二维码有两种状态，一个是登陆，一个是切换， 登陆状态需要隐藏关闭按钮， 切换状态不需要隐藏
    certType = 2, //证书类型 1.ukey 2.移动
    signName = "", //印章名称
    scrollCurrentPage, // 当前进入可视窗口的页码
    /**
     * @typedef SignatureInfo
     * @property {number} left x坐标
     * @property {number} top 处理前的y坐标
     * @property {number} page 页码
     * @property {number} realLeft 相对于后端真实页面宽度的真实x坐标
     * @property {number} realTop 相对于后端真实页面宽度的真实y坐标
     * @property {string} sealImgBase64 图片的base64
     * @property {string} sealId 签章id,
     * @property {number} timeStamp 签章时间戳标识,
     * @property {string} sealType 签章类型 0：公章 2：未知 3：未知 6：未知 7：手绘印章
     */
    /**@type {SignatureInfo[]}*/
    signatureInfo = [], // 印章信息，画印章使用
    /**
     * @typedef SignInfo 签章详情
     * @property {number} llx x坐标(相对于pageWidth的)
     * @property {number} lly 处理前的y坐标(相对于pageWidth的)
     * @property {number} page 页码
     * @property {number} pageWidth 页面宽度（后端传入的真实宽度）
     * @property {number} pageHeight 页面高度（后端传入的真实高度）
     * @property {number} sealWidth 签章宽度（相对于pageWidth的宽度）
     * @property {number} height 签章高度（相对于pageHeight的高度）
     * @property {string} sealId 签章id,
     * @property {number} timeStamp 签章时间戳标识,
     * @property {string} sealType 签章类型 0：公章 2：未知 3：未知 6：未知 7：未知
     */
    /**
     * @type {SignInfo[]} 签章位置,id等信息;点击保存签章时,处理后传给后端
     */
    saveList = []; // 印章信息，保存时使用

/**
 * 获取印章默认值
 * @param {string} type 类型编号
 * @returns {number} 相应类型的默认值
 */
function getSealDefaultSize(type) {
    var DefaultSize = {
        2: frzSealDefaultSize,
        6: agentSealDefaultSize,
        7: sxqmSealDefaultSize,
        3: contractzSealDefaultSize
    };

    return Number(DefaultSize[type] || sealDefaultSize);
}

function deleteSign(row) {
    var index;
    for (var i = 0; i < saveList.length; i++) {
        var item = saveList[i];
        if (
            item.page == row.page &&
            item.sealId == row.sealId &&
            item.timeStamp == row.timeStamp
        ) {
            index = i;
            break;
        }
    }
    if (index > -1) {
        saveList.splice(index, 1);
    }
}
/**
 * 单个签章缩放操作
 * @param {*} row dom的position数据
 */
function signSizeChange(row) {
    // 当前页签章处理

    // 多页签章处理
    for (var i = 0; i < saveList.length; i++) {
        var item = saveList[i];
        if (
            item.page == row.page &&
            item.sealId == row.sealId &&
            item.timeStamp == row.timeStamp
        ) {
            item.sealWidth = fullSize / pageScale / preScale;
            item.height = fullSize / pageScale / preScale;
            // item.realSealHeight = fullSize
            // item.realSealWidth = fullSize
            // item.llx = row.llx / pageScale;
            // item.lly = row.lly / pageScale;
            break;
        }
    }
}

function drow (page) {
    // 遍历需要画的签章信息数组
    signatureInfo.filter(function (item) {
        return item.page == page
    }).forEach(function (item) {
        var options = {
            sealId: item.sealId,
            sealImgBase64: item.sealImgBase64,
            pageNum: page,
            top: item.top,
            left: item.left,
            timeStamp: item.timeStamp,
            realSealLeft: item.realLeft,
            realSealTop: item.realTop,
            type: item.type,
            selectedSealType: item.selectedSealType,
            continuity: true
        }
        // 缩放引起的页面滚动，可能会引起画签章，缩放时有300延时处理缩放比例，所以此处延时需要大于300（缩放延时）
        // setTimeout(function () {
            doCoverMultiPageSealImg(options)
        // }, 301)
    })

    // 从signatureInfo数组遍历删除已画在页面上的签章信息
    signatureInfo = signatureInfo.filter(function (item) {
        return item.page != page
    })
}

document
    .getElementById("viewerContainer")
    .addEventListener("scroll", function () {
        // 当前进入可视窗口的页码
        var currentPage = window.PDFViewerApplication.page;
        
        // 如果当前页码不是第一次进入,则退出
        if (scrollCurrentPage == currentPage) {
            return;
        }
        if(isZoom) {
            zoomPageArr.push(currentPage)
            return
        }
        // 第一次进入,记录,防止在同一页码多次触发下面的循环(每次进入改页面都会触发一次下面的循环)
        scrollCurrentPage = currentPage;
        var len = signatureInfo.length;
        // 判断需要画的签章信息数组是否有内容，有内容则需要画签章
        if (len) {
            // 如果需要画签章
            drow(currentPage)
        }
    });
// 判断当前filePath是否为Url
function isURL(str) {
    var pattern = new RegExp(
        "^(https?:\\/\\/)?" + // protocol
            "((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.?)+[a-z]{2,}|" + // domain name
            "((\\d{1,3}\\.){3}\\d{1,3}))" + // OR ip (v4) address
            "(\\:\\d+)?(\\/[-a-z\\d%_.~+]*)*" + // port and path
            "(\\?[;&a-z\\d%_.~+=-]*)?" + // query string
            "(\\#[-a-z\\d_]*)?$",
        "i"
    ); // fragment locator
    return pattern.test(str);
}
function getParams(name) {
    if (!window.location.search) {
        return "";
    }
    var search = window.location.search.substr(1);
    // var search = '?filepath=http://111.1.30.221:8084/TPBidder2/netztbmis/pages/signature/signdownloadAttachmentAction.action?cmd=download&AttachGuid=e6e7eb2a-a145-4428-a95c-fcd0c1a0878c'.substr(1)
    var fileUrl = search.split("?");
    var fileUrlSearch = fileUrl[1] ? fileUrl[1] : "";
    var fileParams = fileUrlSearch.split("&");
    var str;
    for (var i = 0; i < fileParams.length; i++) {
        var paramsIndex = fileParams[i].indexOf("AttachGuid");
        if (paramsIndex >= 0) {
            str = fileParams[i].split("=")[1];
            return str;
        }
    }
    return "";
}

$(function () {
    var interval = setInterval(function () {
        var pageObj = $("#pageContainer" + window.pageNum);
        var pageWidth = pageObj.width();
        var pdfFileRealWidth = getSpecificPageWidth(window.pageNum);
        minWidth = Math.ceil((pageWidth / pdfFileRealWidth) * 119);
        preScale = PDFViewerApplication.pdfViewer._currentScale;
        scale = PDFViewerApplication.pdfViewer._currentScale;
        totalPages = PDFViewerApplication.pagesCount;
        if (PDFViewerApplication.initialized) {
            //获取当前页数
            PDFViewerApplication.eventBus.on("pagechange", function (e) {
                console.log("wwww", e.pageNumber);
            });
            
            //添加页面缩放事件
            PDFViewerApplication.eventBus.on("scalechange", function (e) {
                // scaleSeal(e.scale);
                isZoom = true
                debounceScaleSeal(e.scale);
            });
            PDFViewerApplication.eventBus.dispatch("scalechanged", {
                source: PDFViewerApplication,
                value: "1",
            });
            clearInterval(interval);
        }
    }, 1000);
    //如果未设置certtype
    if (!urlParams("certtype")) {
        var newurl = updateQueryStringParameter(
            window.location.href,
            "certtype",
            "2"
        );
        //向当前url添加参数，没有历史记录
        window.history.replaceState(
            {
                path: newurl,
            },
            "",
            newurl
        );
    }
    //如果未设置hash值
    if (!urlHash("#page")) {
        var newurl = updateQueryStringParameter(
            window.location.href,
            "#page",
            "1"
        );
        //向当前url添加参数，没有历史记录
        window.history.replaceState(
            {
                path: newurl,
            },
            "",
            newurl
        );
    }

    //获取证书类型
    if (urlParams("certtype") == 1) {
        //设置证书类型
        window.certType = 1;
        setCertType();
    } else {
        //设置证书类型
        window.certType = 2;
        setCertType();
    }

    //判断是否显示PDF顶部提示栏
    if (window.sessionStorage.getItem("closeToolTips") !== "close") {
        $(".toolBar-tips").show();
    }
    //设置公司名称
    $(".toolBar-company-name").html(
        window.localStorage.getItem("givenName") || ""
    );
    // 判断是否显示pdf侧边提示栏
    if (window.localStorage.getItem("toggled") === null) {
        $(".toggled-tips").show();
    }
    //自由签章模式下签章按钮
    $("#localSign").click(function () {
        sign();
    });
    //印章申领成功后，重新请求一次GetSealImgList
    $(".toolBar-select-null .refresh").on("click", function () {
        getSealList();
    });
    //关闭顶部提示栏
    $(".toolBar-tips .close").on("click", function () {
        closeToolTips();
    });
    // 点击查看如何申请
    $(".toolBar #toApply").on("click", function () {
        goApply();
    });
    /**
     * @description: 鼠标移入印章显示签章标签
     * @return {*}  void
     */
    $(".toolBar-select-seal").on(
        "mouseenter",
        ".toolBar-select-seals",
        function () {
            $(this)
                .css("opacity", 1)
                .children()
                .children(".toolBar-select-seals-handle")
                .show();
        }
    );
    /**
     * @description: 鼠标移出印章隐藏签章标签
     * @return {*}  void
     */
    $(".toolBar-select-seal").on(
        "mouseleave",
        ".toolBar-select-seals",
        function () {
            $(this)
                .css("opacity", 0.8)
                .children()
                .children(".toolBar-select-seals-handle")
                .hide();
        }
    );
    /**
     * @description: 鼠标移入问号显示操作说明
     * @return {*}
     */
    $(".toolBar-select-title i").bind("mouseenter", function () {
        $(".handler-tips").show();
    });
    /**
     * @description: 鼠标移出问号隐藏操作说明
     * @return {*}
     */
    $(".toolBar-select-title i").on("mouseleave", function () {
        $(".handler-tips").hide();
    });
    /**
     * @description: 打开操作说明
     * @return {*} viod
     */
    $(".toolBar-select-title i").on("click", function () {
        goViewSignprocess();
        //window.open("./components/operation.html");
    });
    /**
     * @description: 选择签章类型
     * @param {*} data-id 1单页章 2多页章 3骑缝章
     * @return {*} viod
     */
    $(".toolBar-select-seal").on(
        "click",
        ".toolBar-select-seals-handler",
        function () {
            window.signWidth = 119;
            window.signHeight = 119;
            let _id = $(this).attr("data-id");
            // 选中的印章图片
            // console.log($(this)
            // .parent().prev().attr("data-src"))
            // window.selectedSealImgBase64 = $(this)
            //     .parent()
            //     .prev()
            //     .attr("src")
            //     .substring(
            //         $(this).parent().prev().attr("src").indexOf(",") + 1
            //     );
            window.selectedSealImgBase64 = $(this)
                .parent()
                .prev()
                .attr("data-src")
                .substring(
                    $(this).parent().prev().attr("data-src").indexOf(",") + 1
                );
            window.selectedSealId = $(this)
                .parent()
                .parent()
                .parent()
                .attr("data-id");
            window.selectedSealType = $(this)
                .parent()
                .parent()
                .parent()
                .attr("data-type");
            if (_id === "2") {
                //多页章
                signName = $(this).parent().parent().next().html();
                signType = "multiPage";
                totalPages = PDFViewerApplication.pagesCount;
                openMultipage(2);
            } else if (_id === "1") {
                //单页章
                signType = "singlePage";
                doCoverSealImg();
            } else if (_id === "3") {
                //骑缝
                signName = $(this).parent().parent().next().html();
                signType = "QF";
                totalPages = PDFViewerApplication.pagesCount;
                openMultipage(3);
                
            }
        }
    );
    /**
     * @description: 清空页章
     * @return {*} void
     */
    $(".handle-reset").click(function () {
        if (!isExistSeal()) {
            return mAlert("您还没有签章，无需重置。");
        }
        alertTips("确认要重置所有已选印章吗？", "info");
    });

    /**
     * @description: 手动切换证书
     * @return {*} void
     */
    $(".toolBar-switch-sign").click(function () {
        closeQrType = 1;
        // qrcode(1)
        switchQrcode();
    });
    /**
     * @description: 关闭侧边提示栏
     * @param {*} type 1关闭 2不再显示
     * @return {*} void
     */
    $(".tipsClose").click(function () {
        if ($(this).attr("data-type") === "1") {
            $(".toggled-tips").hide();
        } else {
            window.localStorage.setItem("toggled", "close");
            $(".toggled-tips").hide();
        }
    });
});

/**
 * @description: 设置证书类型
 * @param {*} CretType 1:Ukey 2:移动
 * @return {*} void
 */
function setCertType() {
    let params = {
        funcName: "SetCertType",
        param: { certType: window.certType.toString() },
    };
    $.ajax({
        type: "post",
        url: "https://localhost:9819/HxApi",
        data: JSON.stringify(params),
        timeout: 10000,
        dataType: "json",
        success: function (data) {
            if (data.retcode != 0) {
                $(".toolBar-select-seal").hide();
                $(".toolBar-select-null").hide();
                mAlert(
                    data.errinfo || "设置证书类型失败，请检测网络连接再重试。"
                );
                return;
            } else {
                if (data.retvalue.ErrCode == -1) {
                    return mAlert(data.retvalue.ErrValue || "调用控件异常");
                }
                if (data.retcode === 0 && window.certType == 2) {
                    //获取用户登陆状态 是否打开二维码登陆
                    //移动签章
                    return getUserLoginType();
                } else if (data.retcode === 0 && window.certType == 1) {
                    //ukey签章
                    ukeyComName();
                    return getSealList();
                }
            }
        },
        error: function (err) {
            return mAlert("调用控件异常");
        },
    });
}

/**
 * @description: 设置用户信息
 * @return {*} void
 */
function setUserInfo() {
    let params = {
        funcName: "SetUserInfo",
        param: {
            SignCert: userInfoParams.cert,
            EncCert: userInfoParams.encCert,
            certdata: {
                givenName: userInfoParams.certdata.givenName,
                commonName: userInfoParams.certdata.commonName,
                serialNumber: userInfoParams.certdata.serialNumber,
                issuerCn: userInfoParams.certdata.issuerCn,
                startDate: userInfoParams.certdata.startDate,
                finalDate: userInfoParams.certdata.finalDate,
                uniscid: userInfoParams.certdata.uniscid,
                zch: userInfoParams.certdata.zch,
                corpid: "内部序号",
                ou: "ou",
            },
            proxName: userInfoParams.proxName || "",
            proxCardNumber: userInfoParams.proxCardNumber || "",
            proxPhone: userInfoParams.proxPhone || "",
            qrCodeType: userInfoParams.qrCodeType || "",
        },
    };
    $.ajax({
        type: "post",
        url: "https://localhost:9819/HxApi",
        data: JSON.stringify(params),
        dataType: "json",
        timeout: 10000,
        success: function (data) {
            if (data.retcode != 0) {
                mAlert(
                    data.errinfo || "设置用户信息失败，请检测网络连接再重试。"
                );
                return;
            }
            if (data.retcode === 0) {
                if (data.retvalue.ErrCode == -1) {
                    return mAlert(data.retvalue.ErrValue || "调用控件异常");
                }
                //获取印章列表
                getSealList();
            }
        },
        error: function () {
            return mAlert("调用控件异常");
        },
    });
}
/**
 * @description: 进入页面需要被隐藏的元素统一处理
 * @return {*} void
 */
function hideAll() {
    $(".toolBar-select-seals-handle").hide(); //隐藏签章标签
    $(".handler-tips").hide(); //操作说明
}

/**
 * @description: 创建各种印章
 * @return {*} void
 */
function createSeals() {
    var sealInfoArray = window.sealInfoArray;
    var autographList = sealInfoArray.filter(function (item) {
        return item.sealtype == "7";
    });
    var otherSignList = sealInfoArray.filter(function (item) {
        return item.sealtype != "7";
    });
    var element = "";
    if (urlParams("certtype") == 2) {
        //移动证书
        for (let i = 0; i < sealInfoArray.length; i++) {
            // 个人签名 公章的情况下，不去计算
            if (sealInfoArray[i].sealtype === "0") {
                element +=
                    '<div class="toolBar-select-seals" data-type=' +
                    sealInfoArray[i].sealtype +
                    " data-id=" +
                    sealInfoArray[i].sealid +
                    ">" +
                    '<div class="sealImg-box">' +
                    // '<img class="sealImg"' +
                    // "src=" +
                    // "data:image/png;base64," +
                    // sealInfoArray[i].picdata +
                    // ">" +
                    '<div class="sealImg" data-src="data:image/png;base64,' +
                    sealInfoArray[i].picdata +
                    ' " style="background-image: url(data:image/png;base64,' +
                    sealInfoArray[i].picdata +
                    ')">' +
                    "</div>" +
                    '<div class="toolBar-select-seals-handle">' +
                    '<span class="toolBar-select-seals-handler" data-id="1">单页签</span>' +
                    '<span class="toolBar-select-seals-handler" data-id="2">多页签</span>' +
                    '<span class="toolBar-select-seals-handler" data-id="3">骑缝签</span>' +
                    "</div>" +
                    "</div>" +
                    "<p>" +
                    getSealName(sealInfoArray[i].sealtype) +
                    "</p>" +
                    "</div>";
            } else {
                element +=
                    '<div class="toolBar-select-seals" data-type=' +
                    sealInfoArray[i].sealtype +
                    " data-id=" +
                    sealInfoArray[i].sealid +
                    ">" +
                    '<div class="sealImg-box">' +
                    // '<img class="sealImg" ' +
                    // "src=" +
                    // "data:image/png;base64," +
                    // sealInfoArray[i].picdata +
                    // ">" +
                    '<div class="sealImg" data-src="data:image/png;base64,' +
                    sealInfoArray[i].picdata +
                    ' " style="background-image: url(data:image/png;base64,' +
                    sealInfoArray[i].picdata +
                    ')">' +
                    "</div>" +
                    '<div class="toolBar-select-seals-handle">' +
                    '<span class="toolBar-select-seals-handler" data-id="1">单页签</span>' +
                    '<span class="toolBar-select-seals-handler" data-id="2">多页签</span>' +
                    "</div>" +
                    "</div>" +
                    "<p>" +
                    getSealName(sealInfoArray[i].sealtype) +
                    "</p>" +
                    "</div>";
            }
            $(".toolBar-select-seal").html(element);
            //进入页面需要被隐藏的元素统一处理
            hideAll();
        }
    } else {
        //ukey证书
        for (let i = 0; i < sealInfoArray.length; i++) {
            if (sealInfoArray[i].sealtype === "0") {
                element +=
                    '<div class="toolBar-select-seals" data-type=' +
                    sealInfoArray[i].sealtype +
                    " data-id=" +
                    sealInfoArray[i].sealid +
                    ">" +
                    '<div class="sealImg-box">' +
                    // '<img class="sealImg"' +
                    // "src=" +
                    // "data:image/png;base64," +
                    // sealInfoArray[i].picdata +
                    // ">" +
                    '<div class="sealImg" data-src="data:image/png;base64,' +
                    sealInfoArray[i].picdata +
                    ' " style="background-image: url(data:image/png;base64,' +
                    sealInfoArray[i].picdata +
                    ')">' +
                    "</div>" +
                    '<div class="toolBar-select-seals-handle">' +
                    '<span class="toolBar-select-seals-handler" data-id="1">单页签</span>' +
                    '<span class="toolBar-select-seals-handler" data-id="2">多页签</span>' +
                    '<span class="toolBar-select-seals-handler" data-id="3">骑缝签</span>' +
                    "</div>" +
                    "</div>" +
                    "<p>" +
                    getSealName(sealInfoArray[i].sealtype) +
                    "</p>" +
                    "</div>";
            } else {
                element +=
                    '<div class="toolBar-select-seals" data-type=' +
                    sealInfoArray[i].sealtype +
                    " data-id=" +
                    sealInfoArray[i].sealid +
                    ">" +
                    '<div class="sealImg-box">' +
                    // '<img class="sealImg"' +
                    // "src=" +
                    // "data:image/png;base64," +
                    // sealInfoArray[i].picdata +
                    // ">" +
                    '<div class="sealImg" data-src="data:image/png;base64,' +
                    sealInfoArray[i].picdata +
                    ' " style="background-image: url(data:image/png;base64,' +
                    sealInfoArray[i].picdata +
                    ')">' +
                    "</div>" +
                    '<div class="toolBar-select-seals-handle">' +
                    '<span class="toolBar-select-seals-handler" data-id="1">单页签</span>' +
                    '<span class="toolBar-select-seals-handler" data-id="2">多页签</span>' +
                    "</div>" +
                    "</div>" +
                    "<p>" +
                    getSealName(sealInfoArray[i].sealtype) +
                    "</p>" +
                    "</div>";
            }

            $(".toolBar-select-seal").html(element);
            //进入页面需要被隐藏的元素统一处理
            hideAll();
        }
    }
}
// /**
//  * @description: 根据tselType去判断印章宽高
//  * @param {*} sealType 印章类型
//  * @return {*} void
//  */
// function getSealWidth(sealType) {
//     var cssVal = {
//         width: "119px",
//         height: "119px",
//     };
//     if (sealType === "0") {
//         cssVal = {
//             width: "119px",
//             height: "119px",
//         };
//     } else if (sealType === "1") {
//         cssVal = {
//             height: Math.floor((119 / 43) * 26) + "px",
//             width: Math.floor((119 / 43) * 26) + "px",
//         };
//     } else if (sealType === "2") {
//         cssVal = {
//             height: Math.floor((119 / 43) * 20) + "px",
//             width: Math.floor((119 / 43) * 20) + "px",
//         };
//     } else if (sealType === "3") {
//         cssVal = {
//             height: (119 / 1) * 1 + "px",
//             width: (119 / 1) * 1 + "px",
//         };
//     } else if (sealType === "4") {
//         cssVal = {
//             height: Math.floor((119 / 43) * 31) + "px",
//             width: Math.floor((119 / 43) * 41) + "px",
//         };
//     } else if (sealType === "5") {
//         cssVal = {
//             height: (119 / 1) * 1 + "px",
//             width: (119 / 1) * 1 + "px",
//         };
//     } else if (sealType === "6") {
//         cssVal = {
//             height: (119 / 1) * 1 + "px",
//             width: (119 / 1) * 1 + "px",
//         };
//     } else if (sealType === "7") {
//         cssVal = {
//             height: Math.floor((119 / 43) * 16) + "px",
//             width: Math.floor((119 / 43) * 40) + "px",
//         };
//     } else if (sealType === "8") {
//         cssVal = {
//             height: Math.floor((119 / 43) * 20) + "px",
//             width: Math.floor((119 / 43) * 20) + "px",
//         };
//     } else if (sealType === "9") {
//         cssVal = {
//             height: Math.floor((119 / 43) * 13) + "px",
//             width: Math.floor((119 / 43) * 37) + "px",
//         };
//     }
//     return cssVal;
// }
/**
 * @description: 根据tselType去判断印章名称
 * @param {*} sealType 印章类型
 * @return {*} 印章名称
 */
function getSealName(sealType) {
    var sealName = "";
    if (sealType === "0") {
        sealName = "公章";
    } else if (sealType === "1") {
        sealName = "财务章";
    } else if (sealType === "2") {
        sealName = "法人章";
    } else if (sealType === "3") {
        sealName = "合同专用章";
    } else if (sealType === "4") {
        sealName = "发票专用章";
    } else if (sealType === "5") {
        sealName = "其它";
    } else if (sealType === "6") {
        sealName = "经办人章";
    } else if (sealType === "7") {
        sealName = "手绘签名";
    } else if (sealType === "8") {
        sealName = "个人方章 ";
    } else if (sealType === "9") {
        sealName = "个人横章";
    }
    return sealName;
}

/**
 * @description: 打开签章弹框
 * @return {*} void
 */
function openMultipage(type) {
    window.sealType = type;
    if(type === 3) {
        doGetQFSeal()
        return 
    }
    layer.open({
        skin: "custom-layer",
        type: 2,
        closeBtn: 0,
        title: type === 2 ? "多页签章" : "骑缝章",
        maxmin: false,
        area: ["425px", "280px"],
        content: "./components/multipage.html",
        data: type,
        end: function () {
            if (result == null || result == "close") {
                signType = "singlePage";
                return false;
            }
            if (result == "success") {
                // if (type === 3) {
                //     //骑缝
                //     doGetQFSeal();
                // } else 
                if (type === 2) {
                    //多页
                    var pageNum = pageArray[0];
                    var pageObj = $("#pageContainer" + pageNum);
                    var pageWidth = pageObj.width();
                    var pageHeight = pageObj.height();
                    var pdfFileRealWidth = getSpecificPageWidth(pageNum);
                    var scale = pageWidth / pdfFileRealWidth;
                    var sealWidth = Math.ceil(scale * signWidth);
                    var sealHeight = Math.ceil(scale * signWidth);
                    var timeStamp = new Date().getTime();
                    saveList.push({
                        llx: 0,
                        lly: 0,
                        page: pageNum,
                        pageWidth: pageWidth,
                        pageHeight: pageHeight,
                        sealWidth: signWidth,
                        sealId: selectedSealId,
                        sealType: selectedSealType,
                        height: signWidth,
                        timeStamp: timeStamp,
                        endPage: endPage,
                    });
                    var options = {
                        sealId: selectedSealId,
                        sealImgBase64: selectedSealImgBase64,
                        pageNum: pageNum,
                        top: 0,
                        left: 0,
                        timeStamp: timeStamp,
                        realSealLeft: 0,
                        realSealTop: 0,
                    };
                    console.log(saveList)
                    doCoverMultiPageSealImg(options);
                }
            }
        },
    });
}

/**
 * @description: 获取印章列表
 * @return {*} void
 */
function getSealList() {
    var params = {
        funcName: "GetSealImgList",
    };
    $(".toolBar-select-loading").show();
    $.ajax({
        type: "post",
        url: "https://localhost:9819/HxApi",
        data: JSON.stringify(params),
        timeout: 20000,
        dataType: "json",
        success: function (data) {
            $(".toolBar-select-loading").hide();
            if (data.retcode != 0) {
                $(".toolBar-select-seal").hide();
                $(".toolBar-select-null").show();
                mAlert(
                    data.errinfo || "获取印章列表失败，请检测网络连接再重试。"
                );
                return;
            }
            if (data.retvalue.ErrCode == -1) {
                return mAlert(data.retvalue.ErrValue || "调用控件异常");
            }
            var certtype = getURLParameter("certtype");
            data = data.retvalue;
            // if (data.rslt == "success") {
            if (data.rslt == "fail") {
                //如果印章列表为空
                if (data.errorcode == "noAuthSeal") {
                    mAlert(
                        data.errormsg ||
                            "获取印章列表失败，请检测网络连接再重试。"
                    );
                    $(".handle-btn").addClass("reject");
                    $(".toolBar-select-seal").hide();
                    $(".toolBar-select-null").show();
                    return;
                }
                mAlert(data.errormsg);
                return;
            }

            certSerialNum = data.certSn;
            sealInfoArray = data.data;
            //初始化realWidthArray
            $(".handle-btn").removeClass("reject");
            $(".toolBar-select-null").hide();
            $(".toolBar-select-seal").show();
            if (realWidthArray == null) {
                //计算PDF页面宽度
                getRealPageWidth(1, totalPages);
            } else {
                createSeals();
            }
        },
        error: function (err) {
            return mAlert("调用控件异常");
        },
    });
}
/**
 * @description: 计算PDF页面宽度
 * @param {*} startPage 头
 * @param {*} endPage 尾
 * @return {*} void
 */
function getRealPageWidth(startPage, endPage) {
    var params = parseQueryString(document.location.search.substring(1));
    var sourceFile = "filepath" in params ? params.filepath : "";
    if (sourceFile.substr(0, 4) != "http") {
        sourceFile = "";
    } else {
        var index = sourceFile.lastIndexOf("/");
        sourceFile = sourceFile.substring(index + 1, sourceFile.length);
        if (sourceFile.indexOf(".pdf") == -1) {
            sourceFile = sourceFile + ".pdf";
        }
    }
    // sourceFile = 'C://Users/hzhb/Desktop/7777.pdf'
    let param = {
        funcName: "GetPageSize",
        param: {
            filepath: sourceFile,
        },
    };
    $.ajax({
        type: "post",
        async: false,
        url: "https://localhost:9819/HxApi",
        data: JSON.stringify(param),
        timeout: 10000,
        dataType: "json",
        success: function (data) {
            if (data.retcode != 0) {
                mAlert(data.errinfo, function () {
                    if (data.retcode == -5) {
                        window.open(
                            "http://www.linksgood.com/page/client/topic/llianClient3"
                        );
                    }
                });
                return;
            } else {
                if (data.retvalue.ErrCode == -1) {
                    return mAlert(data.retvalue.ErrValue || "调用控件异常");
                }
                realWidthArray = data.retvalue.pageWidth;
                var length = data.retvalue.pageWidth.length;
                if (length) {
                    setTimeout(function () {
                        var pageWidth = $("#pageContainer1").width();
                        // PDFViewerApplication.pdfViewer._currentScale 该值为进入页面时页面默认的缩放比例
                        pageScale =
                            pageWidth /
                            data.retvalue.pageWidth[0].iPageSize / PDFViewerApplication.pdfViewer._currentScale;
                        for (var i = 0; i < length; i++) {
                            var item = data.retvalue.pageWidth[i];
                            realPageInfo[item.iPageNo] = {
                                pageHeight: Math.round(item.iPageHeight),
                                pageWidth: Math.round(item.iPageSize),
                            };
                        }
                    }, 1000);
                }

                //创建各种印章
                createSeals();
            }
        },
        error: function (err) {
            return mAlert("调用控件异常");
        },
    });
}

/**
 * @description: 获取PDF后端接口返回宽度
 * @param {number} pageNum 当前页数
 * @return {number}  PDF后端接口返回宽度
 */
function getSpecificPageWidth(pageNum) {
    var pageInfo = realWidthArray.find(function (item) {
        return item.iPageNo === pageNum;
    }) || { iPageSize: 0 };
    return pageInfo.iPageSize;
}

/**
 * @description: 获取骑缝章图片
 * @return {*} void
 */
function doGetQFSeal() {
    var GZSealId;
    for (var i in sealInfoArray) {
        var sealInfo = sealInfoArray[i];
        if (sealInfo.sealtype == "0") {
            GZSealId = sealInfo.sealid;
        }
    }
    /*  var param = {
    appid: appid,
    time: new Date().Format('yyyyMMddHHmmss'),
    sealId: GZSealId,
    startPage: startPage.toString(),
    endPage: .toString(),
  } */
    var payload = {
        funcName: "GetQfSealImg",
        param: {
            time: new Date().Format("yyyyMMddHHmmss"),
            sealId: GZSealId,
            // startPage: startPage.toString(),
            // endPage: endPage.toString(),
            startPage: '1',
            endPage: PDFViewerApplication.pagesCount.toString(),
        },
    };

    $.ajax({
        type: "post",
        async: false,
        url: "https://localhost:9819/HxApi",
        data: JSON.stringify(payload),
        timeout: 10000,
        dataType: "json",
        success: function (data) {
            if (data.retcode == "0") {
                if (data.retvalue.ErrCode == -1) {
                    return mAlert(data.retvalue.ErrValue || "调用控件异常");
                }
                var retvalue = data.retvalue;
                doCoverQFSealImg(retvalue);
                //保存骑缝章位置信息用于签章
                var qfDataObj = new Object();
                qfDataObj.blocksize = retvalue.blocksize;
                qfDataObj.lastsize = retvalue.lastsize;
                qfDataObj.sealid = GZSealId;
                qfDataObj.pagebegin = 1;
                qfDataObj.pageend = PDFViewerApplication.pagesCount;
                qfDataObj.sealWidth = sealDefaultSize;
                QFDataList.push(qfDataObj);
                mAlert("骑缝章签章位置标记成功，请检查。");
            } else {
                return mAlert("骑缝章签署失败，请重试。");
            }
        },
        error: function (err) {
            return mAlert("调用控件异常");
        },
    });
}

/**
 * @description: 批量添加骑缝章
 * @param {*} retvalue 接口数据返回的位置
 * @return {*} void
 */
function doCoverQFSealImg(retvalue) {
    var sealInfoArray = retvalue.blockimginfo;
    doCoverQFBlock(sealInfoArray);
    sealInfoArray = retvalue.lastimginfo;
    doCoverQFBlock(sealInfoArray);
}

/**
 * @description: 添加骑缝章
 * @param {*} sealInfoArray 骑缝章在PDF上标记的信息
 * @return {*} void
 */
function doCoverQFBlock(sealInfoArray) {
    for (var i = 0; i < sealInfoArray.length; i++) {
        var sealInfo = sealInfoArray[i];
        var pageArray = sealInfo.page;
        
        for (var j = 0; j < pageArray.length; j++) {
            var page = pageArray[j];
            var pageObj = $("#pageContainer" + page);

            //页面的真实大小
            var pageWidth = realPageInfo[page].pageWidth;
            var pageHeight = realPageInfo[page].pageHeight;

            /** 印章的默认大小值 */
            // var defaultSize = getSealDefaultSize(selectedSealType);
            var defaultSize = sealDefaultSize

            /** 每份的真实宽度 */
            var sealWidth = defaultSize / sealInfo.count;
            var sealHeight = defaultSize;
            
            pageObj.createSign(
                {
                    cssClass: "sealClass",
                    sealImgBase64: sealInfo.sealImgBase64,
                    width: sealWidth * preScale * pageScale,
                    height: sealHeight * preScale * pageScale,
                    page: page,
                    top: ((pageHeight - sealHeight) / 2) * preScale * pageScale, //靠右居中显示
                    left: (pageWidth - sealWidth) * preScale * pageScale,
                    type: "QF",
                    sealType: selectedSealType,
                    signSelfType: "qf",
                    realSealWidth: sealWidth,
                    realSealHeight: defaultSize,
                    realSealLeft: pageWidth - sealWidth,
                    realSealTop: (pageHeight - sealHeight) / 2,
                },
                function (llx, lly) {}
            );
        }
    }
}

/**
 * @description: 单页章
 * @return {*} void
 */
function doCoverSealImg() {
    pageNum = PDFViewerApplication.page;
    var pageObj = $("#pageContainer" + pageNum);
    var pageWidth = pageObj.width();
    var pdfFileRealWidth = getSpecificPageWidth(pageNum);
    var scale = pageWidth / pdfFileRealWidth;

    /** 印章的默认大小值 */
    var defaultSize = getSealDefaultSize(selectedSealType);

    var sealWidth = scale * defaultSize;
    var sealHeight = scale * defaultSize;

    pageObj.createSign(
        {
            cssClass: "sealClass",
            sealId: selectedSealId,
            sealImgBase64: selectedSealImgBase64,
            page: pageNum,
            width: Math.ceil(sealWidth),
            height: Math.ceil(sealHeight),
            type: signType,
            sealType: selectedSealType,
            realSealLeft: 0,
            realSealTop: 0,
            realSealWidth: defaultSize,
            realSealHeight: defaultSize,
            signSelfType: "single",
            endMove: function (data) {
                var movEendData = data.signObj.data("position");
                var realSealLeft = movEendData.llx / preScale / pageScale;
                var realSealTop = movEendData.lly / preScale / pageScale;
                data.signObj.data(
                    "position",
                    $.extend({}, movEendData, {
                        realSealTop: realSealTop,
                        realSealLeft: realSealLeft,
                    })
                );
            },
        },
        function (llx, lly) {}
    );
    //跳转到页首
    PDFViewerApplication.page = parseInt(pageNum);
    mAlert("请拖动印章至盖章处");
}

/**
 * @description: 添加多页印章印记
 * @param {*} sealId 印章ID
 * @param {*} sealImgBase64 印章图片
 * @param {*} pageNum 页数
 * @param {*} top 印章top位置
 * @param {*} left 印章left位置
 * @return {*} void
 */
function doCoverMultiPageSealImg(options) {
    var sealId = options.sealId;
    var sealImgBase64 = options.sealImgBase64;
    var pageNum = options.pageNum;
    var top = options.top;
    var left = options.left;
    var scaleWidth = signWidth * pageScale * preScale;

    var pageHeight = realPageInfo[options.pageNum].pageHeight * preScale * pageScale;
    var pageWidth = realPageInfo[options.pageNum].pageWidth * preScale * pageScale;
    if (top < 0) {
        top = 0;
    } else if (top >= pageHeight - scaleWidth) {
        top = pageHeight - scaleWidth;
    }
    if (left < 0) {
        left = 0;
    } else if (left >= pageWidth - scaleWidth) {
        left = pageWidth - scaleWidth;
    }
    var timeStamp = options.timeStamp;
    var realSealLeft = options.realSealLeft || 0;
    var realSealTop = options.realSealTop || 0;
    if (sealImgBase64 == "" || sealImgBase64 == null) {
        mAlert("请先选择印章");
        return;
    }
    var pageObj = $("#pageContainer" + pageNum);
    /** 签章确认时的提示页码文案 */
    
    var tipPages;
    if (pageArray.length == 1) {
        tipPages = pageArray[0];
    } else {
        if (multiPageType == '2') {
            var pages = "";
            for (var i = 0; i < pageArray.length; i++) {
                if (pages == "") {
                    pages = pageArray[i];
                } else {
                    pages += ',' + pageArray[i];
                }
            }
            tipPages = pages;
        } else {
            tipPages = pageArray[0] + "-" + pageArray[pageArray.length - 1] ;
        }
    }
    pageObj.createSign(
        {
            cssClass: "sealClass",
            sealImgBase64: sealImgBase64,
            width: scaleWidth,
            height: scaleWidth,
            page: pageNum,
            sealId: sealId,
            type: options.type || signType,
            top: top,
            left: left,
            pageArray: pageArray,
            sealType: options.selectedSealType || selectedSealType,
            signSelfType: "multiple",
            timeStamp: timeStamp,
            /** 签章真实宽高 */
            realSealWidth: signWidth,
            realSealHeight: signWidth,
            /** 签章真实left,Top */
            realSealLeft: realSealLeft,
            realSealTop: realSealTop,
            tipPages: tipPages,
            endMove: function (data) {
                var signObj = data.signObj;
                var movEendData = signObj.data("position");
                saveList.forEach(function (item) {
                    if (
                        item.sealId == movEendData.sealId &&
                        item.page == movEendData.page &&
                        item.timeStamp == movEendData.timeStamp
                    ) {
                        item.llx = movEendData.llx / pageScale / preScale;
                        item.lly = movEendData.lly / pageScale / preScale;
                        item.pageWidth =
                            realPageInfo[movEendData.page].pageWidth;
                        item.pageHeight =
                            realPageInfo[movEendData.page].pageHeight;
                    }
                });
                signObj.data(
                    "position",
                    $.extend({}, movEendData, {
                        realSealLeft: movEendData.llx / preScale / pageScale,
                        realSealTop: movEendData.lly / preScale / pageScale,
                    })
                );
                if (signObj.attr("data-type") == "multiPage") {
                    var content = "您确定在" + movEendData.tipPages + "页中放置该印章吗？";
                    mConfirm(content, function () {
                        signType = "singlePage";
                        var multiPageInfo = signObj.data("multiPageInfo");
                        var multiPageArray = multiPageInfo.pageArray;
                        var sealId = multiPageInfo.sealId;
                        var sealImgBase64 = multiPageInfo.sealImgBase64;
                        
                        for (var i = 1; i < multiPageArray.length; i++) {
                            var page = multiPageArray[i];
                            var pageWidth = realPageInfo[page].pageWidth;
                            var pageHeight = realPageInfo[page].pageHeight;
                            signatureInfo.push(
                                $.extend({}, multiPageInfo, {
                                    left: movEendData.llx,
                                    top: movEendData.lly,
                                    pageHeight: pageHeight * preScale * pageScale,
                                    // left: movEendData.llx / preScale / pageScale,
                                    // top: movEendData.lly / preScale / pageScale,
                                    realLeft:
                                        movEendData.llx / preScale / pageScale,
                                    realTop:
                                        movEendData.lly / preScale / pageScale,
                                    page: multiPageArray[i],
                                    timeStamp: timeStamp,
                                    type: "singlePage",
                                    selectedSealType: selectedSealType,
                                })
                            );
                            saveList.push({
                                llx: movEendData.llx / pageScale / preScale,
                                lly: movEendData.lly / pageScale / preScale,
                                page: page,
                                pageWidth: realPageInfo[page].pageWidth,
                                pageHeight: realPageInfo[page].pageHeight,
                                sealWidth: signWidth,
                                height: signWidth,
                                sealId: sealId,
                                sealType: selectedSealType,
                                timeStamp: timeStamp,
                            });
                        }
                        console.log(signatureInfo)
                        signObj.attr("data-type", "singlePage");
                    });
                }
            },
        },
        function (llx, lly) {}
    );
    //跳转到页首
    if (signType == "multiPage" && !options.continuity) {
        PDFViewerApplication.page = Number(pageNum);
        mAlert("请拖动印章至盖章处");
    }
}

/**
 * @description: 封装的提示框
 * @param {*} msg 消息
 * @param {*} success 状态
 * @return {*} void
 */
function mConfirm(msg, success) {
    layer.confirm(msg, { icon: 3, title: "提示" }, function (index) {
        if (success && typeof success == "function") {
            success();
        }
        layer.close(index);
    });
}

/**
 * @description: 重置弹出组件
 * @param {*} message 提示消息
 * @return {*} void
 */
function alertTips(message, type) {
    tipsMessag = message;
    tipsType = type;
    layer.open({
        skin: "custom-layer",
        type: 2,
        title: "提示",
        closeBtn: 0,
        maxmin: false,
        area: ["349px", "196px"],
        content: "./components/alertTips.html",
        end: function () {
            if (result == null || result == "close") {
                return false;
            }
            if (result == "backClose") {
                return false;
            }
            if (result == "success") {
                window.location.reload();
                return false;
            }
            if (result == "reset") {
                clearSign();
                return false;
            }
        },
    });
}

/**
 * @description: 打开二维码弹窗
 * @param {*} type  1登陆二维码 2签名二维码
 * @return {*} void
 */
function qrcode(type) {
    window.qrCodetype = type;
    layer.open({
        skin: "custom-layer",
        type: 2,
        title: "移动数字证书认证",
        maxmin: false,
        closeBtn: closeQrType,
        area: ["329px", "396px"],
        content: "./components/toolqrcode.html",
        cancel: function () {
            // 右上角关闭事件的逻辑
            //如果用户手动关闭需要释放二维码接口
            if (window.qrCodetype === 2) {
                return freeQrcode();
            }
        },
        end: function () {
            //设置二维码成功后需要判断是否是网络上传
            if (result === "qrcodeOK") {
                if (window.qrCodetype === 2) {
                    var saveType = getURLParameter("saveType");
                    var savePath = getURLParameter("savePath");
                    var token = getURLParameter("token");
                    if (
                        saveType == null ||
                        saveType == "" ||
                        savePath == null ||
                        savePath == "" ||
                        token == null ||
                        token == ""
                    ) {
                        // alertTips('签章成功，请务必检查文档中印章是否正确', 'success')55
                        mTips(
                            "签章保存成功，请务必检查文档中印章是否正确",
                            function () {
                                location.reload();
                            }
                        );
                    } else {
                        uploadSign();
                    }
                }
                return false;
            }
            if (result === "success") {
                return false;
            }
        },
    });
}

/**
 * @description: 切换数字证书
 * @return {*} void
 */
function switchQrcode() {
    window.qrCodetype = 1;
    layer.open({
        skin: "custom-layer",
        type: 2,
        title: "请选择法人数字证书类型",
        maxmin: false,
        closeBtn: closeQrType,
        area: ["766px", "440px"],
        content: "./components/toolqrcodeukey.html",
        cancel: function () {
            // 右上角关闭事件的逻辑
        },
        end: function () {
            console.log("关闭");
        },
    });
}

/**
 * @description: 如果用户手动关闭需要释放二维码接口
 * @return {*} void
 */
function freeQrcode() {
    let param = {
        funcName: "FreeFile",
    };
    $.ajax({
        type: "post",
        async: false,
        url: "https://localhost:9819/HxApi",
        data: JSON.stringify(param),
        timeout: 10000,
        dataType: "json",
        success: function (data) {
            if (data.retcode != 0) {
                return mAlert(data.errinfo);
            } else {
                if (data.retvalue.ErrCode == -1) {
                    return mAlert(data.retvalue.ErrValue || "调用控件异常");
                }
            }
        },
        error: function (err) {
            return mAlert("调用控件异常");
        },
    });
}
/**
 * @description: 公用弹出组件
 * @param {*} msg 消息
 * @param {*} func 回调
 * @return {*} void
 */
function mAlert(msg, func) {
    layer.alert(
        msg,
        {
            icon: typeof func === "number" ? func : 0,
            title: "提示",
        },
        function (index) {
            if (func && typeof func == "function") {
                func();
            }
            layer.close(index);
        }
    );
}

/**
 * @description: 检验是否有印章存在
 * @return {*} void
 */
function isExistSeal() {
    var sealImg = $("div[name='freeSignSeal']");
    // if (sealImg.length != 0) {
    //   return true;
    // }
    // return false;
    if (saveList.length || sealImg.length) {
        return true;
    }
    return false;
}
/**
 * @description: 检验是否有骑缝章
 * @return {*} void
 */
function isExistQFSeal() {
    var sealImg = $("div[name='QFSeal']");
    if (sealImg.length != 0) {
        return true;
    }
    return false;
}
/**
 * @description: 查询缓存
 * @param {*} name 查询参数
 * @return {*} 缓存值
 */
function getURLParameter(name) {
    return (
        decodeURIComponent(
            (new RegExp("[?|&]" + name + "=" + "([^&;]+?)(&|#|;|$)").exec(
                location.search
            ) || [, ""])[1].replace(/\+/g, "%20")
        ) || null
    );
}

/**
 * @description: 查询信息类型
 * @param {*} obj 信息
 * @return {*} boolean
 */
function isBlank(obj) {
    if (obj == null || typeof obj == "undefined" || obj == "") {
        return true;
    }
    return false;
}
/**
 * @description: 印章处理中的展示
 * @param {*} msg 展示信息
 * @return {*} void
 */
function showloading(msg) {
    if (isBlank(msg)) {
        msg = "正在处理，请稍等...";
    }
    return layer.msg(msg, {
        icon: 16,
        shade: [0.5, "#f5f5f5"],
        scrollbar: false,
        time: 100000,
    });
}
/**
 * @description: 查询url参数
 * @param {*} query 参数名
 * @return {*} 参数
 */
function parseQueryString(query) {
    var parts = query.split("&");
    var params = {};
    for (var i = 0, ii = parts.length; i < ii; ++i) {
        var param = parts[i].split("=");
        var key = param[0].toLowerCase();
        var value = param.length > 1 ? param[1] : null;
        params[decodeURIComponent(key)] = decodeURIComponent(value);
    }
    return params;
}

/**
 * @description: 弹窗
 * @param {*} msg 消息
 * @param {*} func 回调
 * @return {*} void
 */
function mTips(msg, func) {
    layer.msg(
        msg,
        {
            //icon: 0, //0:! 1:对号 2：×
            time: 3500, //2秒关闭（如果不配置，默认是3秒）
        },
        function () {
            if (func && typeof func == "function") {
                func();
            }
        }
    );
}

/**
 * @description: 关闭loading
 * @param {*} index layerIndex
 * @return {*} void
 */
function hiddenLoading(index) {
    layer.close(index);
}
/**
 * @description: 保存签章
 * @return {*} void
 */
function sign() {
    if (!isExistSeal()) {
        if (isExistQFSeal()) {
            mAlert("请先点当前页签章后，再操作骑缝章。");
            return;
        } else {
            mAlert("您还没有签章，无需保存。");
            return;
        }
    }

    mConfirm("在您标记的印章位签章", function (layerIndex) {
        layer.close(layerIndex);
        //签章位置集合
        var positionList = new Array();
        var sealPosition = new Object();
        var sealStartPage = 0;
        var sealEndPage = 0;
        var frzPosition = new Object();
        var frzStartPage = 0;
        var frzEndPage = 0;
        // 增加合同章类型对应参数
        var  contractzPosition = new Object();
        var  contractzStartPage = 0;
        var  contractzEndPage = 0;
        var sxqmPosition = new Object();
        var sxqmStartPage = 0;
        var sxqmEndPage = 0;
        var agentPosition = new Object();
        var agentStartPage = 0;
        var agentEndPage = 0;
        var continuous;
        var continuousArray = new Array();
        var index;
        $("div[name='freeSignSeal']").each(function () {
            var selfPosition = $(this).data("position");
            if (selfPosition.signSelfType == "multiple") {
                return;
            }
            var position = {};
            position.x = Math.round(selfPosition.realSealLeft);
            position.y =
                realPageInfo[selfPosition.page].pageHeight -
                selfPosition.realSealTop -
                selfPosition.realSealHeight;
            position.y = Math.floor(position.y);
            position.page = selfPosition.page;
            position.pageWidth = Math.round(
                realPageInfo[selfPosition.page].pageWidth
            );
            position.sealid = selfPosition.sealId;
            position.sealWidth = Math.floor(selfPosition.realSealWidth);
            positionList.push(position);
        });
        // var myEndPage = saveList[0].endPage
        var selfEndPage;
        saveList.forEach(function (item) {
            if(item.endPage) {
                console.log('selfEndPage',item.endPage)
                selfEndPage = item.endPage
            }
            var position = {};
            //获取每个印章的宽度。
            position.x = Math.floor(item.llx);
            if (position.x < 0) {
                position.x = 0;
            } else if (item.llx + Number(item.sealWidth) > item.pageWidth) {
                position.x = Math.floor(item.pageWidth - item.sealWidth);
            }
            position.y = Math.floor(item.pageHeight - item.lly - item.height);
            if (position.y < 0) {
                position.y = 0;
            } else if (item.lly + Number(item.height) > item.pageHeight) {
                position.y = Math.floor(item.pageHeight - item.height);
            }
            position.page = item.page;
            position.pageWidth = Math.floor(item.pageWidth);
            position.sealid = item.sealId;

            position.sealWidth = Math.floor(item.sealWidth);
            if ("2" == item.sealType) {
                if (
                    frzPosition.x == position.x &&
                    frzPosition.y == position.y &&
                    frzPosition.pageWidth == position.pageWidth &&
                    frzPosition.sealWidth == position.sealWidth &&
                    frzPosition.page == position.page - 1
                ) {
                    //连续相同位置
                    frzEndPage = position.page;
                    //移除存在的元素
                    for (var i = 0; i < positionList.length; i++) {
                        var item = positionList[i];
                        if (
                            item.page == frzPosition.page &&
                            item.pageWidth == frzPosition.pageWidth &&
                            item.sealWidth == frzPosition.sealWidth &&
                            item.sealid == frzPosition.sealid &&
                            item.x == frzPosition.x &&
                            item.y == frzPosition.y
                        ) {
                            index = i;
                            break;
                        } else {
                            index = -1;
                        }
                    }
                    if (index != -1) {
                        positionList.splice(index, 1);
                    }
                    if (position.page == selfEndPage) {
                        continuous = new Object();
                        continuous.startPage = frzStartPage;
                        continuous.endPage = frzEndPage;
                        continuous.x = Math.round(position.x);
                        continuous.y = Math.round(position.y);
                        continuous.sealid = position.sealid;
                        continuous.pageWidth = Math.round(position.pageWidth);
                        continuous.sealWidth = Math.round(position.sealWidth);
                        continuousArray.push(continuous);
                        frzEndPage = 0;
                    }
                } else {
                    if (
                        frzStartPage != frzEndPage &&
                        frzStartPage != 0 &&
                        frzEndPage != 0
                    ) {
                        continuous = new Object();
                        continuous.startPage = frzStartPage;
                        continuous.endPage = frzEndPage;
                        continuous.x = Math.round(frzPosition.x);
                        continuous.y = Math.round(frzPosition.y);
                        continuous.sealid = frzPosition.sealid;
                        continuous.pageWidth = Math.round(
                            frzPosition.pageWidth
                        );
                        continuous.sealWidth = Math.round(
                            frzPosition.sealWidth
                        );
                        continuousArray.push(continuous);
                        frzEndPage = 0;
                    }
                    positionList.push(position);
                    frzStartPage = position.page;
                }
                frzPosition = position;
            } else if ("3" == item.sealType) {
                if (
                    contractzPosition.x == position.x &&
                    contractzPosition.y == position.y &&
                    contractzPosition.pageWidth == position.pageWidth &&
                    contractzPosition.sealWidth == position.sealWidth &&
                    contractzPosition.page == position.page - 1
                ) {
                    //连续相同位置
                    contractzEndPage = position.page;
                    //移除存在的元素
                    //   index = positionList.indexOf(contractzPosition);
                    for (var i = 0; i < positionList.length; i++) {
                        var item = positionList[i];
                        if (
                            item.page == contractzPosition.page &&
                            item.pageWidth == contractzPosition.pageWidth &&
                            item.sealWidth == contractzPosition.sealWidth &&
                            item.sealid == contractzPosition.sealid &&
                            item.x == contractzPosition.x &&
                            item.y == contractzPosition.y
                        ) {
                            index = i;
                            break;
                        } else {
                            index = -1;
                        }
                    }
                    if (index != -1) {
                        positionList.splice(index, 1);
                    }
                    if (position.page == selfEndPage) {
                        continuous = new Object();
                        continuous.startPage = contractzStartPage;
                        continuous.endPage = contractzEndPage;
                        continuous.x = Math.round(position.x);
                        continuous.y = Math.round(position.y);
                        continuous.sealid = position.sealid;
                        continuous.pageWidth = Math.round(position.pageWidth);
                        continuous.sealWidth = Math.round(position.sealWidth);
                        continuousArray.push(continuous);
                        contractzEndPage = 0;
                    }
                } else {
                    if (
                        contractzStartPage != contractzEndPage &&
                        contractzStartPage != 0 &&
                        contractzEndPage != 0
                    ) {
                        continuous = new Object();
                        continuous.startPage = contractzStartPage;
                        continuous.endPage = contractzEndPage;
                        continuous.x = Math.round(contractzPosition.x);
                        continuous.y = Math.round(contractzPosition.y);
                        continuous.sealid = contractzPosition.sealid;
                        continuous.pageWidth = Math.round(
                            contractzPosition.pageWidth
                        );
                        continuous.sealWidth = Math.round(
                            contractzPosition.sealWidth
                        );
                        continuousArray.push(continuous);
                        contractzEndPage = 0;
                    }
                    positionList.push(position);
                    contractzStartPage = position.page;
                }
                contractzPosition = position;
            } else if ("7" == item.sealType) {
                if (
                    sxqmPosition.x == position.x &&
                    sxqmPosition.y == position.y &&
                    sxqmPosition.pageWidth == position.pageWidth &&
                    sxqmPosition.sealWidth == position.sealWidth &&
                    sxqmPosition.page == position.page - 1
                ) {
                    //连续相同位置
                    sxqmEndPage = position.page;
                    //移除存在的元素
                    //   index = positionList.indexOf(sxqmPosition);
                    for (var i = 0; i < positionList.length; i++) {
                        var item = positionList[i];
                        if (
                            item.page == sxqmPosition.page &&
                            item.pageWidth == sxqmPosition.pageWidth &&
                            item.sealWidth == sxqmPosition.sealWidth &&
                            item.sealid == sxqmPosition.sealid &&
                            item.x == sxqmPosition.x &&
                            item.y == sxqmPosition.y
                        ) {
                            index = i;
                            break;
                        } else {
                            index = -1;
                        }
                    }
                    if (index != -1) {
                        positionList.splice(index, 1);
                    }
                    if (position.page == selfEndPage) {
                        continuous = new Object();
                        continuous.startPage = sxqmStartPage;
                        continuous.endPage = sxqmEndPage;
                        continuous.x = Math.round(position.x);
                        continuous.y = Math.round(position.y);
                        continuous.sealid = position.sealid;
                        continuous.pageWidth = Math.round(position.pageWidth);
                        continuous.sealWidth = Math.round(position.sealWidth);
                        continuousArray.push(continuous);
                        sxqmEndPage = 0;
                    }
                } else {
                    if (
                        sxqmStartPage != sxqmEndPage &&
                        sxqmStartPage != 0 &&
                        sxqmEndPage != 0
                    ) {
                        continuous = new Object();
                        continuous.startPage = sxqmStartPage;
                        continuous.endPage = sxqmEndPage;
                        continuous.x = Math.round(sxqmPosition.x);
                        continuous.y = Math.round(sxqmPosition.y);
                        continuous.sealid = sxqmPosition.sealid;
                        continuous.pageWidth = Math.round(
                            sxqmPosition.pageWidth
                        );
                        continuous.sealWidth = Math.round(
                            sxqmPosition.sealWidth
                        );
                        continuousArray.push(continuous);
                        sxqmEndPage = 0;
                    }
                    positionList.push(position);
                    sxqmStartPage = position.page;
                }
                sxqmPosition = position;
            } else if ("6" == item.sealType) {
                if (
                    agentPosition.x == position.x &&
                    agentPosition.y == position.y &&
                    agentPosition.pageWidth == position.pageWidth &&
                    agentPosition.sealWidth == position.sealWidth &&
                    agentPosition.page == position.page - 1
                ) {
                    //连续相同位置
                    agentEndPage = position.page;
                    //移除存在的元素
                    //   index = positionList.indexOf(agentPosition);
                    for (var i = 0; i < positionList.length; i++) {
                        var item = positionList[i];
                        if (
                            item.page == agentPosition.page &&
                            item.pageWidth == agentPosition.pageWidth &&
                            item.sealWidth == agentPosition.sealWidth &&
                            item.sealid == agentPosition.sealid &&
                            item.x == agentPosition.x &&
                            item.y == agentPosition.y
                        ) {
                            index = i;
                            break;
                        } else {
                            index = -1;
                        }
                    }
                    if (index != -1) {
                        positionList.splice(index, 1);
                    }
                    if (position.page == selfEndPage) {
                        continuous = new Object();
                        continuous.startPage = agentStartPage;
                        continuous.endPage = agentEndPage;
                        continuous.x = Math.round(position.x);
                        continuous.y = Math.round(position.y);
                        continuous.sealid = position.sealid;
                        continuous.pageWidth = Math.round(position.pageWidth);
                        continuous.sealWidth = Math.round(position.sealWidth);
                        continuousArray.push(continuous);
                        agentEndPage = 0;
                    }
                } else {
                    if (
                        agentStartPage != agentEndPage &&
                        agentStartPage != 0 &&
                        agentEndPage != 0
                    ) {
                        continuous = new Object();
                        continuous.startPage = agentStartPage;
                        continuous.endPage = agentEndPage;
                        continuous.x = Math.round(agentPosition.x);
                        continuous.y = Math.round(agentPosition.y);
                        continuous.sealid = agentPosition.sealid;
                        continuous.pageWidth = Math.round(
                            agentPosition.pageWidth
                        );
                        continuous.sealWidth = Math.round(
                            agentPosition.sealWidth
                        );
                        continuousArray.push(continuous);
                        agentEndPage = 0;
                    }
                    positionList.push(position);
                    agentStartPage = position.page;
                }
                agentPosition = position;
            } else {
                //为了连续相同章
                if (
                    sealPosition.x == position.x &&
                    sealPosition.y == position.y &&
                    sealPosition.pageWidth == position.pageWidth &&
                    sealPosition.sealWidth == position.sealWidth &&
                    sealPosition.page == position.page - 1
                ) {
                    //连续相同位置
                    sealEndPage = position.page;
                    //移除存在的元素
                    for (var i = 0; i < positionList.length; i++) {
                        var item = positionList[i];
                        if (
                            item.page == sealPosition.page &&
                            item.pageWidth == sealPosition.pageWidth &&
                            item.sealWidth == sealPosition.sealWidth &&
                            item.sealid == sealPosition.sealid &&
                            item.x == sealPosition.x &&
                            item.y == sealPosition.y
                        ) {
                            index = i;
                            break;
                        } else {
                            index = -1;
                        }
                    }
                    if (index != -1) {
                        positionList.splice(index, 1);
                    }
                    if (position.page == selfEndPage) {
                        //到文档最后一页 位置信息可取当前页
                        continuous = new Object();
                        continuous.startPage = sealStartPage;
                        continuous.endPage = sealEndPage;
                        continuous.x = Math.round(position.x);
                        continuous.y = Math.round(position.y);
                        continuous.sealid = position.sealid;
                        continuous.pageWidth = Math.round(position.pageWidth);
                        continuous.sealWidth = Math.round(position.sealWidth);
                        continuousArray.push(continuous);
                        sealEndPage = 0;
                    }
                } else {
                    if (
                        sealStartPage != sealEndPage &&
                        sealStartPage != 0 &&
                        sealEndPage != 0
                    ) {
                        //连续信息到上一页结束 位置信息取上一页信息
                        continuous = new Object();
                        continuous.startPage = sealStartPage;
                        continuous.endPage = sealEndPage;
                        continuous.x = Math.round(sealPosition.x);
                        continuous.y = Math.round(sealPosition.y);
                        continuous.sealid = sealPosition.sealid;
                        continuous.pageWidth = Math.round(
                            sealPosition.pageWidth
                        );
                        continuous.sealWidth = Math.round(
                            sealPosition.sealWidth
                        );
                        continuousArray.push(continuous);
                        sealEndPage = 0;
                    }
                    positionList.push(position);
                    sealStartPage = position.page;
                }
                sealPosition = position;
            }
        });
        var position = new Object();
        // position.filepath = 'C://Users/hzhb/Desktop/7777.pdf'
        position.data = positionList;
        position.qfdata = QFDataList;
        position.continuousPage = continuousArray;
        var saveType = getURLParameter("saveType");
        var savePath = getURLParameter("savePath");
        var token = getURLParameter("token");
        var layerId = showloading("正在保存签章中，请勿做任何操作。");
        var params = parseQueryString(document.location.search.substring(1));
        var sourceFile = "filepath" in params ? params.filepath : "";
        if (sourceFile.substr(0, 4) != "http") {
            sourceFile = "";
        } else {
            var index = sourceFile.lastIndexOf("/");
            sourceFile = sourceFile.substring(index + 1, sourceFile.length);
            if (sourceFile.indexOf(".pdf") == -1) {
                sourceFile = sourceFile + ".pdf";
            }
        }
        var payload = {
            funcName: "GetTobeSign",
            // param: JSON.parse(setParamBuffer(JSON.stringify(position), "position")),
            param: position,
        };
        $.ajax({
            type: "post",
            url: "https://localhost:9819/HxApi",
            data: JSON.stringify(payload),
            dataType: "json",
            // async: false,
            success: function (data) {
                hiddenLoading(layerId);
                if (data.retcode != 0) {
                    mAlert(data.errinfo);
                    return;
                } else {
                    if (data.retvalue.ErrCode == -1) {
                        return mAlert(data.retvalue.ErrValue || "调用控件异常");
                    }
                    if (window.certType == 2) {
                        //移动签章
                        window.hashData = data.retvalue.hashdata;
                        closeQrType = 1;
                        qrcode(2);
                    } else {
                        //ukey签章
                        // console.log('ukey签章')
                        if (
                            saveType == null ||
                            saveType == "" ||
                            savePath == null ||
                            savePath == "" ||
                            token == null ||
                            token == ""
                        ) {
                            mTips(
                                "签章保存成功，请务必检查文档中印章是否正确",
                                function () {
                                    var newurl = updateQueryStringParameter(
                                        window.location.href,
                                        "#page",
                                        window.PDFViewerApplication.page
                                    );
                                    //向当前url添加参数，没有历史记录
                                    window.history.replaceState(
                                        {
                                            path: newurl,
                                        },
                                        "",
                                        newurl
                                    );
                                    location.reload();
                                }
                            );
                        } else {
                            uploadSign();
                        }
                    }
                }
            },
            error: function (err) {
                hiddenLoading(layerId);
                mAlert("签章失败");
            },
        });
    });
}

/**
 * @description: 获取用户受否登陆 是否需要弹出二维码登陆
 * @return {*} void
 */
function getUserLoginType() {
    var params = {
        funcName: "GetUserLoginType",
    };
    $.ajax({
        type: "post",
        url: "https://localhost:9819/HxApi",
        data: JSON.stringify(params),
        dataType: "json",
        timeout: 10000,
        success: function (data) {
            if (data.retcode !== 0) {
                return mAlert("获取用户登陆状态失败，请检测网络连接再重试。");
            } else {
                if (data.retvalue.ErrCode == -1) {
                    return mAlert(data.retvalue.ErrValue || "调用控件异常");
                }
            }
            if (data.retvalue.LoginType == 0) {
                closeQrType = 0;
                //未登录
                qrcode(1);
            } else if (data.retvalue.LoginType == 1) {
                // 已登陆
                getSealList();
            } else if (data.retvalue.LoginType == 2) {
                // 已登陆
                getSealList();
                //未登录
                // qrcode(1)
            }
        },
        error: function (err) {
            return mAlert("调用控件异常");
        },
    });
}

function debounce(func, delay) {
    var timer;
    return function () {
        var context = this; // 注意 this 指向
        var args = arguments; // arguments中存着e
        if (timer) clearTimeout(timer);
        timer = setTimeout(function () {
            return func.apply(context, args);
        }, delay);
    };
}
var debounceScaleSeal = debounce(scaleSeal, 300);

/**
 * @description: 页面缩放时调整印章大小
 * @param {*} scale pdf缩放百分比
 * @return {*} void
 */
// function scaleSeal(scale) {
//     aftScale = scale;
//     scale = aftScale / preScale;
//     var pageObj = $("#pageContainer" + window.pageNum);
//     var pageWidth = pageObj.width();
//     var pdfFileRealWidth = window.getSpecificPageWidth(window.pageNum);
//     //获取不同缩放基数下最小的宽度，以用于拉伸的最小宽度。
//     minWidth = Math.ceil((pageWidth / pdfFileRealWidth) * 119);
//     $("div[name='freeSignSeal'],div[name='QFSeal']").each(function () {
//         var width = $(this).width() * scale;
//         var height = $(this).height() * scale;
//         $(this).css({ width: width, height: height });
//         var top = $(this).position().top * scale;
//         var left = $(this).position().left * scale;
//         $(this).css({ top: top, left: left });

//         var positionData = $(this).data("position");
//         var llx = positionData.llx * scale;
//         var lly = positionData.lly * scale;
//         var page = positionData.page;
//         var pageWidth = positionData.pageWidth * scale;
//         var signSelfType = positionData.signSelfType;
//         var sealId = positionData.sealId;
//         var type = positionData.type;
//         var sealType = positionData.sealType;
//         var timeStamp = positionData.timeStamp;
//         $(this).data("position", {
//             llx: llx,
//             lly: lly,
//             page: page,
//             sealId: sealId,
//             pageWidth: pageWidth,
//             type: type,
//             sealType: sealType,
//             signSelfType: signSelfType,
//             timeStamp: timeStamp,
//         });
//     });
//     signatureInfo.forEach(function (element) {
//         element.top = element.top * scale;
//         element.left = element.left * scale;
//         // element.sealWidth = element.sealWidth * scale
//         // element.height = element.sealWidth * scale
//     });
//     preScale = aftScale;
// }
function scaleSeal(scale) {
    // 获取到缩放比例
    aftScale = scale;
    var pageObj = $("#pageContainer" + window.pageNum);
    var pageWidth = pageObj.width();
    var pdfFileRealWidth = window.getSpecificPageWidth(window.pageNum);
    minWidth = Math.ceil((pageWidth / pdfFileRealWidth) * 119);
    $("div[name='freeSignSeal'],div[name='QFSeal']").each(function () {
        var $dom = $(this);
        var info = $dom.data("position");
        var width = info.realSealWidth * pageScale * scale;
        var height = info.realSealHeight * pageScale * scale;
        var top = info.realSealTop * scale * pageScale;
        var left = info.realSealLeft * scale * pageScale;
        var llx = left;
        var lly = top;
        $dom.css({ width: width, height: height, top: top, left: left });
        $dom.data("position", $.extend({}, info, { llx: llx, lly: lly }));
    });
    signatureInfo.forEach(function (element) {
        element.top = element.realTop * scale * pageScale;
        element.left = element.realLeft * scale * pageScale;
    });
    // 当前页面相对于100%的缩放比例
    preScale = aftScale;
    // 缩放对应逻辑处理完成,画签章
    isZoom = false
    if(zoomPageArr.length) {
        for(var i = 0; i < zoomPageArr.length; i++ ) {
            var page = zoomPageArr.shift()
            drow(page)
        }
    }
}

/**
 * @description: 获取url中的参数
 * @param {*} variable
 * @return {*} 返回url中参数
 */
function urlParams(variable) {
    var query = window.location.search.substring(1);
    var vars = query.split("&");
    for (var i = 0; i < vars.length; i++) {
        var pair = vars[i].split("=");
        if (pair[0] == variable) {
            return pair[1];
        }
    }
    return false;
}

/**
 * @description: 获取url中的hash
 * @param {*} val
 * @return {*} 返回url中的hash
 */
function urlHash(val) {
    const w = location.hash.indexOf("?");
    const query = location.hash.substring(w + 1);
    const vars = query.split("&");
    for (let i = 0; i < vars.length; i++) {
        const pair = vars[i].split("=");
        if (pair[0] == val) {
            return pair[1];
        }
    }
    return false;
}

/**
 * @description: 上传签章文件
 * @return {*} void
 */
function uploadSign() {
    var saveType = getURLParameter("saveType");
    var savePath = getURLParameter("savePath");
    var token = getURLParameter("token");
    var params = parseQueryString(document.location.search.substring(1));
    var sourceFile = "filepath" in params ? params.filepath : "";
    if (sourceFile.substr(0, 4) != "http") {
        sourceFile = "";
    } else {
        var index = sourceFile.lastIndexOf("/");
        sourceFile = sourceFile.substring(index + 1, sourceFile.length);
        if (sourceFile.indexOf(".pdf") == -1) {
            sourceFile = sourceFile + ".pdf";
        }
    }
    var uploadLoading = showloading("正在上传签章文件中，请勿做任何操作。");
    $.ajax({
        type: "get",
        async: true,
        url: "https://localhost:9819/?method=81",
        data: {
            type: saveType,
            filepath: savePath,
            token: token,
            sourceFile: sourceFile,
        },
        timeout: 10000,
        dataType: "jsonp",
        jsonp: "callback", //传递给请求处理程序或页面的，用以获得jsonp回调函数名的参数名(一般默认为:callback)
        jsonpCallback: "myjsonpcall", //自定义的jsonp回调函数名称，默认为jQuery自动生成的随机函数名，也可以写"?"，jQuery会自动为你处理数据
        success: function (data) {
            hiddenLoading(uploadLoading);
            if (data.retcode != 0) {
                mAlert(data.errinfo);
                return;
            } else {
                if (data.retvalue.ErrCode == -1) {
                    return mAlert(data.retvalue.ErrValue || "调用控件异常");
                }
                // alertTips('签章成功，请务必检查文档中印章是否正确', 'success')
                mTips(
                    "签章保存成功，请务必检查文档中印章是否正确",
                    function () {
                        location.reload();
                    }
                );
            }
        },
        error: function (err) {
            return mAlert("调用控件异常");
        },
    });
}
/**
 * @description: url追加参数
 * @param {*} uri url
 * @param {*} key 参数名
 * @param {*} value 参数值
 * @return {*} void
 */
function updateQueryStringParameter(uri, key, value) {
    if (!value) {
        return uri;
    }
    var re = new RegExp("([?&])" + key + "=.*?(&|$)", "i");
    var separator = uri.indexOf("?") !== -1 ? "&" : "?";
    if (uri.match(re)) {
        return uri.replace(re, "$1" + key + "=" + value + "$2");
    } else {
        return uri + separator + key + "=" + value;
    }
}

/**
 * @description: 清除样章
 * @return {*} void
 */
function clearSign() {
    var sealImg = $("div[name='freeSignSeal'],div[name='QFSeal']");
    sealImg.remove();
    /** 清空签章信息 */
    saveList = [];
    signatureInfo = [];
    QFDataList = []
}

/**
 * @description: 设置公司名称
 * @return {*} void
 */
function settingComName(name) {
    $(".toolBar-company-name").html(name);
}

/**
 * @description: 获取Ueky公司名称
 * @param {*} name ueky公司名称
 * @return {*} void
 */
function ukeyComName() {
    let params = {
        funcName: "GetUkeyCertContent",
    };
    $.ajax({
        type: "post",
        url: "https://localhost:9819/HxApi",
        data: JSON.stringify(params),
        timeout: 10000,
        dataType: "json",
        success: function (data) {
            if (data.retcode != 0) {
                mAlert(
                    data.errinfo || "设置证书类型失败，请检测网络连接再重试。"
                );
                return;
            } else {
                if (data.retvalue.ErrCode == -1) {
                    return mAlert(data.retvalue.ErrValue || "调用控件异常");
                }
                window.localStorage.removeItem("givenName");
                window.localStorage.setItem(
                    "givenName",
                    data.retvalue.givenName
                );
                settingComName(data.retvalue.givenName); //设置公司名字
            }
        },
        error: function (err) {
            return mAlert("调用控件异常");
        },
    });
}

/**
 * @description: 关闭顶部提示栏
 * @return {*} void
 */
function closeToolTips() {
    // window.localStorage.getItem('givenName') || ''
    window.sessionStorage.setItem("closeToolTips", "close");
    $(".toolBar-tips").hide();
}
/**
 * @description: 查看如何申请
 */
function goApply() {
    $.ajax({
        type: "get",
        url: "https://localhost:9819/?method=82&url=http://zsfwpt.icinfo.cn/app/applyStep.html",
        timeout: 10000,
        dataType: "json",
        success: function (data) {},
        error: function (err) {},
    });
}

/**
 * @description: 查看如何申请
 */
function goViewSignprocess() {
    $.ajax({
        type: "get",
        url: "https://localhost:9819/?method=82&url=https://localhost:9819/Web/web/components/operation.html",
        success: function (data) {},
        error: function (err) {},
    });
}
