(function ($) {
    $.fn.createSign = function (options, callback) {
        var defaults = {
            width: "119.5",
            height: "119.5",
            top: "0",
            left: "0",
            cssClass: "sealClass",
            page: "1",
        };
        var opts = $.extend(defaults, options);
        if (!opts["sealImgBase64"]) {
            throw new Error("必须设置签章图片。");
            return;
        }
        // 骑缝章时,跳过边界处理
        // 传入的left按真实宽高处理过了,如果处理,未渲染页面通过下面的 this.width() 拿到的页面的宽度是默认宽度，非页面实际宽度，会导致处理的数据不正确
        // if (opts.type != "QF") {
        //     //防止印章越过界
        //     if (opts.left < 0) {
        //         opts.left = 0;
        //     } else if (opts.left >= this.width() - opts.width) {
        //         opts.left = this.width() - opts.width;
        //     }
        //     if (opts.top < 0) {
        //         opts.top = 0;
        //     } else if (opts.top >= this.height() - opts.height) {
        //         opts.top = this.height() - opts.height;
        //     }
        // }
        //生成一个div
        var signObj = $("<div/>").css({
            width: opts.width,
            height: opts.height,
            top: opts.top,
            left: opts.left,
            position: "absolute",
            "z-index": "1",
            opacity: "1",
            border: "1px dashed #000",
        });
        if (opts.type == "multiPage") {
            //多页
            var signImage = $("<div/>").css({
                width: 100 + "%",
                height: 100 + "%",
                top: opts.top,
                left: opts.left,
                "background-image":
                    "url('data:image/png;base64," + opts.sealImgBase64 + "')",
                "background-repeat": "no-repeat",
                "background-size": "contain",
                "background-position": "center center",
                "z-index": "1",
            });
            var delTips = "<p class='delTips'>删除</p>";
            var flexTips = "<p class='flexTips'>缩放</p>";
            var delButton =
                "<button name='delButton' class='btn delButton'></button>";
            var flexButton =
                "<button name='flexButton' class='btn flexButton'></button>";
            signObj.append(delButton);
            signObj.append(delTips);
            signObj.append(flexTips);
            signObj.append(flexButton);
            signObj.append(signImage);
            signObj.children(".delTips").css({
                "margin-left": "0",
                width: "39px",
                height: "24px",
                "text-align": "center",
                "line-height": "24px",
                position: "absolute",
                "z-index": "9",
                bottom: "20px",
                left: "-17px",
                background: "#000",
                "border-radius": "2px%",
                color: "#fff",
                "font-size": "14px",
            });
            signObj.children(".flexTips").css({
                "margin-left": "0",
                width: "39px",
                height: "24px",
                "text-align": "center",
                "line-height": "24px",
                position: "absolute",
                "z-index": "9",
                bottom: "20px",
                right: "-17px",
                background: "#000",
                "border-radius": "2px%",
                color: "#fff",
                "font-size": "14px",
            });
            signObj.children(".delButton").css({
                "margin-left": "0",
                width: "24px",
                height: "24px",
                position: "absolute",
                "z-index": "9",
                bottom: "-10px",
                left: "-10px",
                background: "#000",
                "border-radius": "50%",
                "background-image": "url('./css/images/tool-del.svg')",
                "background-repeat": "no-repeat",
                "background-position": "center center",
            });
            signObj.children(".flexButton").css({
                "margin-left": "0",
                width: "24px",
                height: "24px",
                position: "absolute",
                "z-index": "9",
                bottom: "-10px",
                right: "-10px",
                background: "#000",
                "border-radius": "50%",
                "background-image": "url('./css/images/tool-suofan.svg')",
                "background-repeat": "no-repeat",
                "background-position": "center center",
                cursor: "se-resize",
            });
            //绑定点击删除事件
            signObj.children("[name='delButton']").click(function (e) {
                e.stopPropagation();
                var row = $(e.target).parent().data("position");
                mConfirm("确认要删除当前签章位置吗？", function () {
                    signObj.remove();
                    window.deleteSign(row);
                });
            });
            signObj.attr("name", "freeSignSeal");
            //如果是多页签章，则给signObj加上标识
            signObj.attr("data-type", "multiPage");
            //记录要加印章的页数，图片base64以及图片id
            signObj.data("multiPageInfo", {
                pageArray: opts.pageArray,
                sealImgBase64: opts.sealImgBase64,
                sealId: opts.sealId,
            });
        } else if (opts.type == "QF") {
            //骑缝
            signObj.css({
                border: "none",
                "background-image":
                    "url('data:image/png;base64," + opts.sealImgBase64 + "')",
                "background-repeat": "no-repeat",
                "background-size": "contain",
                "background-position": "center center",
            });
            signObj.attr("name", "QFSeal");
        } else {
            //单页和关键字
            var signImage = $("<div/>").css({
                width: 100 + "%",
                height: 100 + "%",
                top: opts.top,
                left: opts.left,
                "background-image":
                    "url('data:image/png;base64," + opts.sealImgBase64 + "')",
                "background-repeat": "no-repeat",
                "background-size": "contain",
                "background-position": "center center",
                "z-index": "1",
            });
            var delTips = "<p class='delTips'>删除</p>";
            var flexTips = "<p class='flexTips'>缩放</p>";
            var delButton =
                "<button name='delButton' class='btn delButton'></button>";
            var flexButton =
                "<button name='flexButton' class='btn flexButton'></button>";
            signObj.append(delTips);
            signObj.append(flexTips);
            signObj.append(delButton);
            signObj.append(flexButton);
            signObj.append(signImage);
            signObj.children(".delTips").css({
                "margin-left": "0",
                width: "39px",
                height: "24px",
                "text-align": "center",
                "line-height": "24px",
                position: "absolute",
                "z-index": "9",
                bottom: "20px",
                left: "-17px",
                background: "#000",
                "border-radius": "2px%",
                color: "#fff",
                "font-size": "14px",
            });
            signObj.children(".flexTips").css({
                "margin-left": "0",
                width: "39px",
                height: "24px",
                "text-align": "center",
                "line-height": "24px",
                position: "absolute",
                "z-index": "9",
                bottom: "20px",
                right: "-17px",
                background: "#000",
                "border-radius": "2px%",
                color: "#fff",
                "font-size": "14px",
            });
            signObj.children(".delButton").css({
                "margin-left": "0",
                width: "24px",
                height: "24px",
                position: "absolute",
                "z-index": "9",
                bottom: "-10px",
                left: "-10px",
                background: "#000",
                "border-radius": "50%",
                "background-image": "url('./css/images/tool-del.svg')",

                "background-repeat": "no-repeat",
                "background-position": "center center",
            });
            signObj.children(".flexButton").css({
                "margin-left": "0",
                width: "24px",
                height: "24px",
                position: "absolute",
                "z-index": "9",
                bottom: "-10px",
                right: "-10px",
                background: "#000",
                "border-radius": "50%",
                "background-image": "url('./css/images/tool-suofan.svg')",
                "background-repeat": "no-repeat",
                "background-position": "center center",
                cursor: "se-resize",
            });
            //绑定点击删除事件
            signObj.children("[name='delButton']").click(function (e) {
                e.stopPropagation();
                var row = $(e.target).parent().data("position");
                mConfirm("确认要删除当前签章位置吗？", function () {
                    signObj.remove();
                    window.deleteSign(row);
                });
            });
            signObj.attr("name", "freeSignSeal");
        }
        signObj.addClass("seal");
        if (opts.cssClass) {
            signObj.addClass(opts.cssClass);
        }
        this.append(signObj);
        setTimeout(function () {
            $(".delTips").hide();
            $(".flexTips").hide();
        }, 2000);
        var realSealLeft = opts.left / window.preScale / window.pageScale;
        var realSealTop = opts.top / window.preScale / window.pageScale;
        // var _default_lly = this.height() - opts.top - signObj.height();
        //默认位置
        signObj.data("position", {
            llx: opts.left,
            lly: opts.top,
            page: opts.page,
            sealId: opts.sealId,
            pageWidth: this.width(),
            type: opts.type,
            sealType: opts.sealType,
            signSelfType: opts.signSelfType,
            timeStamp: opts.timeStamp,
            realSealWidth: opts.realSealWidth,
            realSealHeight: opts.realSealHeight,
            realSealLeft: realSealLeft || opts.realSealLeft,
            realSealTop: realSealTop || opts.realSealTop,
            tipPages: opts.tipPages
        });

        var moveAreaObj = this;
        var isDrag = false;
        var startX, startY, startLeft, startTop;

        if (opts.type != "QF") {
            var posix = {};
            var left = 0;
            var top = 0;
            signImage.mousedown(function (event) {
                event.stopPropagation();
                $(this).css("cursor", "move");
                var offset = $(this).offset();
                var x = event.pageX - offset.left;
                var y = event.pageY - offset.top;
                var signImage = $(this);
                $(document).bind("mousemove", function (event) {
                    left = event.pageX - x - moveAreaObj.offset().left;
                    top = event.pageY - y - moveAreaObj.offset().top;
                    setPosition({ left: left, top: top });
                });
                $(document)
                    .unbind("mouseup")
                    .bind("mouseup", function () {
                        signImage.css("cursor", "default");
                        if (
                            opts["endMove"] &&
                            typeof opts["endMove"] == "function"
                        ) {
                            opts["endMove"]({
                                signObj: signObj,
                                left: left,
                                top: top,
                            });
                        }
                        $(this).unbind("mousemove mouseup");
                        $(".flexButton").unbind("mousemove mouseup");
                        $(".delButton").unbind("mousemove mouseup");
                    });
            });
            //鼠标拖拽放大缩小
            signObj.children(".flexButton").mousedown(function (event) {
                var row = $(event.target).parent().data("position");
                event.stopPropagation();
                posix = {
                    w: signObj.width(),
                    h: signObj.height(),
                    x: event.pageX,
                    y: event.pageY,
                };
                console.log("posix", posix);
                console.log("moveAreaObj", moveAreaObj);
                $(document).bind("mousemove", function (e) {
                    console.log(e);
                    e.preventDefault();
                    signObj.css({
                        width:
                            e.pageX - moveAreaObj.offset().left >=
                            moveAreaObj.width()
                                ? signObj.width()
                                : Math.max(
                                      window.minWidth,
                                      e.pageX - posix.x + posix.w
                                  ),
                        height: Math.max(
                            window.minWidth,
                            e.pageY - posix.y + posix.h
                        ),
                    });
                    return false;
                });
                $(document)
                    .unbind("mouseup")
                    .bind("mouseup", function () {
                        var pageObj = $("#pageContainer" + window.pageNum);
                        var pageWidth = pageObj.width();
                        var pdfFileRealWidth = window.getSpecificPageWidth(
                            window.pageNum
                        );
                        var scale = pageWidth / pdfFileRealWidth;
                        signObj.css({
                            height: signObj.width(),
                        });
                        //提交后端的参数
                        // window.signWidth = Math.floor(signObj.width() / scale)
                        // window.signHeight = Math.floor(signObj.width() / scale)
                        //实际宽度
                        window.fullSize = Math.floor(signObj.width());
                        $(event.target)
                            .parent()
                            .data(
                                "position",
                                $.extend(
                                    {},
                                    $(event.target).parent().data("position"),
                                    {
                                        realSealWidth:
                                            Math.floor(signObj.width()) /
                                            window.pageScale /
                                            window.preScale,
                                        realSealHeight:
                                            Math.floor(signObj.height()) /
                                            window.pageScale /
                                            window.preScale,
                                    }
                                )
                            );
                        window.signSizeChange(row);
                        console.log(window.signWidth, "定位结果");
                        console.log(window.scale, "定位比例");
                        signObj.css("cursor", "default");
                        $(this).unbind("mousemove mouseup");
                    });
            });
        }

        //提示
        function mConfirm(msg, success) {
            layer.confirm(msg, { icon: 3, title: "提示" }, function (index) {
                if (success && typeof success == "function") {
                    success();
                }
                layer.close(index);
            });
        }

        //设置印章位置
        function setPosition(offset) {
            var left = offset.left;
            var top = offset.top;
            if (left < 0) {
                left = 0;
            } else if (left >= moveAreaObj.width() - signObj.width()) {
                left = moveAreaObj.width() - signObj.width();
            }

            if (top < 0) {
                top = 0;
            } else if (top >= moveAreaObj.height() - signObj.height()) {
                top = moveAreaObj.height() - signObj.height();
            }
            signObj.css({ left: left + "px", top: top + "px" });
            // var lly = moveAreaObj.height() - top - signObj.height();
            var positionData = signObj.data("position");
            var realSealWidth = positionData.realSealWidth;
            var realSealHeight = positionData.realSealHeight;
            //签章新位置
            signObj.data("position", {
                llx: left,
                lly: top,
                page: opts.page,
                sealId: opts.sealId,
                pageWidth: moveAreaObj.width(),
                type: opts.type,
                sealType: opts.sealType,
                signSelfType: opts.signSelfType,
                timeStamp: opts.timeStamp,
                realSealWidth: realSealWidth || opts.realSealWidth,
                realSealHeight: realSealHeight || opts.realSealHeight,
                realSealLeft: opts.realSealLeft,
                realSealTop: opts.realSealTop,
                tipPages: opts.tipPages
            });
            if (callback) {
                callback(left, top);
            }
        }
        return signObj;
    };
})(jQuery);
